;============================================================
;     ANNUAIRE by ERIC GRUSON
;============================================================

	NOLIST
	include			doorsos.h
	include			userlib.h
	include			graphlib.h
	include			filelib.h
	include			ziplib.h
	LIST

	xdef			_main
	xdef			_comment
	xdef			_ti92plus

view: macro
	move.l	d6,-(a7)
	move.l	\1,d6
	bsr		Debug
	move.l	(a7)+,d6
	endm

Nb_Str: MACRO						; nb, format, string
	movem.l			d0-d7/a0-a6,-(a7)
	move.w			\1,-(a7)
	pea				\2(pc)
	pea				\3(pc)
	jsr				doorsos::sprintf
	lea				10(a7),a7
	movem.l			(a7)+,d0-d7/a0-a6
	ENDM

;***************************************************************
;*  POINT D'ENTREE
;***************************************************************

_main:

	SetFont		#0
	lea			titre,a0
	jsr			graphlib::clr_scr2
	movem.l		d0-d6/a0-a6,-(a7)
	clr.w		d0
	clr.w		d1
	move.w		#238,d2
	move.w		#2,d3
	jsr			graphlib::horiz
	WriteStrA	#0,#2,#4,a0
	clr.w		d0
	move.w		#238,d2
	move.w		#8,d1
	jsr			graphlib::horiz
	movem.l		(a7)+,d0-d6/a0-a6

	clr.l		d2
	move.w		#118,d0
	move.w		#18,d1
	lea			image,a0
	clr.b		d3
	jsr			graphlib::put_sprite_mask


;***************************************************************
;* PREPARATION DES DIFFERENTS FICHIERS : 'NOM' et 'ANNU'
;***************************************************************

	move.w		#0,archive				; fichier non archiver par defaut

	move.w		#1,d1					; cherche le 1 fichier 'annu'
	lea			name2,a0
	jsr			filelib::search	
	move.l		a0,vatadr				; sauve l'adr de 'annu' (adr en VAT)

	cmp.w		#0,d0
	bne			_M00					

;*********************
;* Cration de Annu
;* si non existence
;*********************
										
	lea			name1,a0
	move.w		#1,d1

	jsr			filelib::search			; recherche folder contenant 'nom'
	lea			name2,a0
	jsr			filelib::createfile		; cre le fichier dans mme folder
	move.w		#48,d0
	jsr			filelib::resizefile

	lea			name2,a0
	jsr			filelib::search	
	move.l		a0,vatadr				; sauve l'adr de 'annu' (adr en VAT)

	bra			_M01

;*********************
;* Existence ...
;*********************

;=====================
;= Histoire de arch.
;=====================		RMQ:Nous avons bien en d0.w le handle du fichier
;									et en a0.l adr en Vat de 'annu'

_M00:
	movem.l		d0-d7/a0-a6,-(a7)
	btst		#1,10(a0)
	beq			_M00_unarch

	move.w		#1,archive

	movem.l		d0/a0,-(a7)
	DEREF		d0,a1							; a1 = adresse du deb vat
	movem.l		(a7)+,d0/a0

	sub.l		a1,a0
	move.w		a0,d1							; d1 = adr rel

	move.w		d1,-(a7)						; adresse relative du fich en FAT
	move.w		d0,-(a7)						; folder handle
	clr.l		-(a7)
    jsr         doorsos::EM_moveSymFromExtMem    ; Unarchive !
	addq.l		#8,a7

_M00_unarch
	movem.l		(a7)+,d0-d7/a0-a6

;=====================
;= Histoire du ZIP
;=====================
				
	movem.l		d0-d7/a0-a6,-(a7)
	move.w		12(a0),d0				; handle du fichier annu
	DEREF		d0,a1
	move.w		(a1),d0					; taille du fichier annu
	add.l		d0,a1
	subq.l		#3,a1

	cmp.b		#$53,(a1)+				; ? "S" de SAV
	bne			_M00_non
	cmp.b		#$41,(a1)+				; ? "A" de SAV
	bne			_M00_non
	cmp.b		#$56,(a1)+				; ? "V" de SAV
	bne			_M00_non
	subq.l		#3,a1
	move.b		#$5A,(a1)+				; -> "Z"
	move.b		#$49,(a1)+				; -> "I"
	move.b		#$50,(a1)+				; -> "P"

_M00_non:
	movem.l		(a7)+,d0-d7/a0-a6

	jsr			ziplib::iscomp			; est il dja extrait ???
	tst.w		d0
	bne			_M01
	clr.b		d0
	jsr			ziplib::zipfile			; on dezippe 'annu'

_M01:
	movem.l		d1-d7/a0-a6,-(a7)
	push.w		#3
	jsr			doorsos::ST_busy			; clears BUSY flag
	addq.l		#2,a7
	movem.l		(a7)+,d1-d7/a0-a6


;***************************************************************
;* MENU PRINCIPAL
;***************************************************************

	SetFont		#0
	lea			titre,a0
	jsr			graphlib::clr_scr2
	movem.l		d0-d6/a0-a6,-(a7)
	clr.w		d0
	clr.w		d1
	move.w		#238,d2
	move.w		#2,d3
	jsr			graphlib::horiz
	WriteStrA	#0,#2,#4,a0
	clr.w		d0
	move.w		#238,d2
	move.w		#8,d1
	jsr			graphlib::horiz
	movem.l		(a7)+,d0-d6/a0-a6



	SetFont		#0
	clr.l		d2
	move.w		#118,d0
	move.w		#18,d1
	lea			image,a0
	clr.b		d3
	jsr			graphlib::put_sprite_mask

_MainKey:
	lea			blanc,a6
	bsr			_idle_loop
	cmp			#264,d0					; ESC ?
	beq			_exit
	move.w		d0,d1
_MK00:
	move.w		d1,d0	
	cmp			#268,d0					; F1 ?
	beq			_mainF1
	cmp			#269,d0					; F2 ?
	beq			_mainF2
	cmp			#270,d0					; F3 ?
	beq			_mainF3
	cmp			#271,d0					; F4 ?
	beq			_mainF4

	bra			_MainKey				; sinon on recommence : Attente ...

;====================
;Si F1 est appuy
;====================

_mainF1:
	move.w		#0,d0					; x
	move.w		#9,d1					; y
	move.w		#2,d2					; nb lments
	lea			noms,a0					; liste d'lments
	jsr			userlib::smallmenu
	cmp			#337,d1					; pad droit ?
	beq			_mainF3
	cmp			#340,d1					; pad gauche ?
	beq			_mainF2
	cmp			#0,d2					; Enter ?
	bne			_MK00					; sinon on revient au menu principal
	cmp			#1,d0					; choix : 1
	beq			_Affiche				;	-> Affichage d'un nom
	cmp			#2,d0					; ckoix : 2
	beq			_Find					;	-> Recherche de nom
	bra			_MK00					; sinon on revient

;====================
;Si F2 est appuy
;====================

_mainF2:
	move.w		#43,d0					; x
	move.w		#9,d1					; y
	move.w		#1,d2					; nb lments
	lea			dates,a0				; liste d'lments
	jsr			userlib::smallmenu
	cmp			#337,d1					; pad droit ?
	beq			_mainF1
	cmp			#340,d1					; pad gauche ?
	beq			_mainF3
	cmp			#0,d2					; Enter ?
	bne			_MK00					; -> non on revient au menu principal
	bra			_Date					; -> oui on cherche
	

;====================
;Si F3 est appuy
;====================

_mainF3:
	move.w		#83,d0					; x
	move.w		#9,d1					; y
	move.w		#3,d2					;nb lments
	lea			gest,a0					;liste d'lments
	jsr			userlib::smallmenu
	cmp			#337,d1					; pad droite ?
	beq			_mainF2
	cmp			#340,d1					; pad gauche ?
	beq			_mainF1
	cmp			#0,d2					; Enter ?
	bne			_MK00					; sinon on revient au menu principal
	cmp			#1,d0					; choix : 1
	beq			_Ajout					;	-> Ajouter un nom
	cmp			#2,d0					; choix : 2
	beq			_Modif					;	-> Modifier un nom
	cmp			#3,d0					; choix : 3
	beq			_Retire					;	-> Retirer un nom
	bra			_MK00					; sinon on revient

;====================
;Si F4 est appuy
;====================

_mainF4:
	bra			_About


;***************************************************************
;* AFFICHER UN NOM (F1 = 1)
;***************************************************************

_Affiche:
	move.w		#1,d3					; elment slctionn au dbut...
	clr.w		var
	bsr			_Liste
_Af:
	tst.w		var						; touche appuyer = lettre
	beq			_Aff					; sinon on continue les tests

;=========================================
; Dernire touche = lettre -> recherche
;=========================================

	lea			var,a1
	bsr			_Nbnom
	move.w		d0,d7					; d7 = nb de nom dans annu
	subq.w		#1,d7
	bra			_Find2					; on recherche...

;=========================================
; Affichage pure
;=========================================
	
_Aff:
	cmp.w		#0,d0					; si il y a eu un pb, quit....
	beq			_M01
_Aff0:
	movem.l		d0-d6/a0-a6,-(a7)
	SetFont		#0
	lea			titre,a0
	jsr			graphlib::clr_scr2
	clr.w		d0
	clr.w		d1
	move.w		#238,d2
	move.w		#2,d3
	jsr			graphlib::horiz
	WriteStrA	#0,#2,#4,a0
	clr.w		d0
	move.w		#238,d2
	move.w		#8,d1
	jsr			graphlib::horiz
	movem.l		(a7)+,d0-d6/a0-a6

	move.w		d0,d3					; d3 = index du nom slctionn
	subq.w		#1,d0
	mulu.w		#152,d0
	addq.w		#2,d0					; on positionne le pointeur sur le dbut
	bsr			_Adr					; de l'adresse memoire ou est stock
	add.l		d0,a0					; le nom selectionn
	move.l		a0,pos

;============================
; Nom
;============================
	
	SetFont		#2						; Gros carac
	WriteStrA	#20,#30,#4,a0
	SetFont		#0						; on rtablit petit carac
	move.l		pos,a0
	add.l		#24,a0
	move.l		a0,pos

;============================
; Adresse
;============================

	WriteStrA	#30,#48,#4,a0
	move.l		pos,a0
	add.l		#31,a0
	move.l		a0,pos

;============================
; Ville
;============================

	WriteStrA	#30,#56,#4,a0
	move.l		pos,a0
	add.l		#28,a0
	move.l		a0,pos
	
;============================
; Telephone
;============================

	WriteStrA	#30,#70,#4,a0
	move.l		pos,a0
	add.l		#15,a0
	move.l		a0,pos
	
;============================
; Portable
;============================

	WriteStrA	#30,#78,#4,a0
	move.l		pos,a0
	add.l		#15,a0
	move.l		a0,pos
	
;============================
; Anniversaire
;============================

	WriteStrA	#40,#86,#4,a0
	move.l		pos,a0
	add.l		#9,a0
	move.l		a0,pos
	
;============================
; Fete
;============================

	WriteStrA	#40,#94,#4,a0
	move.l		pos,a0
	add.l		#6,a0
	move.l		a0,pos
	
;============================
; E-mail
;============================

	WriteStrA	#30,#106,#4,a0

;==================================================
; Visualisation rapide grace au PAD
;==================================================

_Aff99:
	lea			datehelp,a6
	bsr			_idle_loop
	cmp			#264,d0					; ESC ?
	beq			_M01
	move.l		d0,d1
	cmp.w		#KEY_DOWN,d0			; BAS ??
	beq			_Aff_down
	cmp.w		#KEY_UP,d0				; HAUT ??
	beq			_Aff_up

	bra			_Aff99					; sinon on traite les autres touches

;============================
; Bas
;============================

_Aff_down:
	bsr			_Nbnom
	cmp			d0,d3
	beq			_Aff_d0
	addq.w		#1,d3
	move.w		d3,d0
	bra			_Aff0
_Aff_d0:
	move.w		#1,d0
	bra			_Aff0

;============================
; Haut
;============================

_Aff_up:
	move.w		d3,d0
	cmp			#1,d3
	beq			_Aff_h0
	subq.w		#1,d3
	move.w		d3,d0
	bra			_Aff0
_Aff_h0:
	bsr			_Nbnom
	bra			_Aff0

;***************************************************************
;* RECHERCHER UN NOM (F1 = 2)
;***************************************************************

_Find:
	lea			titre,a0
	jsr			graphlib::clr_scr2
	movem.l		d0-d6/a0-a6,-(a7)
	clr.w		d0
	clr.w		d1
	move.w		#238,d2
	move.w		#2,d3
	jsr			graphlib::horiz
	WriteStrA	#0,#2,#4,a0
	clr.w		d0
	move.w		#238,d2
	move.w		#8,d1
	jsr			graphlib::horiz
	movem.l		(a7)+,d0-d6/a0-a6	; on cre l'environnement

	WriteStr	#10,#25,#4,trouver

	bsr			_Nbnom
	move.w		d0,d7					; d7 = nb de nom dans annu
	tst.w		d0
	beq			_Fi20					; si aucun nom = erreur
	subq.w		#1,d7

	lea			nb_str,a0
	addq.l		#2,a0
	move.l		a0,pos					; petite astuce :p

	move.w		#40,d1
	move.w		#40,d2
	move.w		#23,d3
	lea			blanc,a6
	bsr			_InputStr
	move.l		a0,a1					; sauve l'adresse string dans a1
	cmp.w		#$FFFF,d0				; Esc ?
	beq			_M01					;  -> quit...
_Find0:
	bsr			_Adr
	addq.l		#2,a0					; on met correctement l'adresse


;===================
; On teste
;===================

	move.l		a0,a2
	move.l		a1,a3

_Fi00:
	cmp.b		(a0)+,(a1)+
	bne			_Fi01
	tst.b		(a1)					; 0 de fin de str ? si oui identique !
	bne			_Fi00

;===================
; Identique...
;===================

	bsr			_Nbnom
	tst.w		d7						; est ce le dernier nom
	bne			_Fi21					;	-> on test le suivant
_Fi001:
	sub.w		d7,d0					; d0 = n du nom trouv
	bra			_Aff0					; on affiche le nom car le seul
	
;===================
; Diffrentes...
;===================

_Fi01:
	move.l		a2,a0
	add.l		#152,a0					; on passe au mot suivant
	move.l		a0,a2					; on re-sauve

	move.l		a3,a1					; restauration de a1

	dbra		d7,_Fi00				; boucle selon nb de nom

;===================
; Aucun nom trouv
;===================

	lea			err_find,a6
	bsr			_Dialog
	bra			_M01

;===================
; Aucun nom mem
;===================

_Fi20:
	lea			err_nom,a6
	bsr			_Dialog
	bra			_M01

;===================
; On re-teste...
;===================
	
_Fi21:
	move.l		a2,a0
	add.l		#152,a0					; on passe au mot suivant
	move.l		a3,a1					; restauration de a1
_Fi22:
	cmp.b		(a0)+,(a1)+
	bne			_Fi001
	tst.b		(a1)					; 0 de fin de str ? si oui identique !
	bne			_Fi22

;===================
; 2 Identiques...
;===================

	bsr			_Nbnom
	sub.w		d7,d0					; d0 = n du nom trouv
	move.w		d0,d3
	clr.w		var						; on restaure l'appui d'une touche
	bsr			_Liste					; on affiche la liste
	bra			_Af						; on affiche le nom slectionn

;***************************************************************
;* RECHERCHER (Rapide)
;***************************************************************

_Find2:
	bsr			_Nbnom
	move.w		d0,d7					; d7 = nb de nom dans annu
	subq.w		#1,d7
	bsr			_Adr
	addq.l		#2,a0					; on met correctement l'adresse

;===================
; On teste
;===================

	move.l		a0,a2
	move.l		a1,a3
_Find200:
	cmp.b		(a0)+,(a1)+
	beq			_Find201

;===================
; Au suivant...
;===================

	move.l		a2,a0
	add.l		#152,a0					; on passe au mot suivant
	move.l		a0,a2					; on re-sauve
	move.l		a3,a1					; restauration de a1

	dbra		d7,_Find200				; boucle selon nb de nom
	
;===================
; Aucun nom trouv
;===================

	clr.w		var						; on restaure l'appui d'une touche
	bsr			_Liste					; on affiche la liste
	bra			_Af						; on affiche le nom 

;===================
; 2 Identiques...
;===================

_Find201:
	bsr			_Nbnom
	sub.w		d7,d0					; d0 = n du nom trouv
	move.w		d0,d3
	clr.w		var						; on restaure l'appui d'une touche
	bsr			_Liste					; on affiche la liste
	bra			_Af						; on affiche le nom slectionn

;***************************************************************
;* RECHERCHE DE DATE ( F2 )
;***************************************************************

_Date:

	clr.w		nbitem

;=================================
; Allocation Handle
;=================================
	
	bsr			_Nbnom
	tst.w		d0
	bne			_Da_H01				; si aucun nom en mem = erreur

;----------------
; Erreur Nom
;----------------

	lea			err_nom,a6
	bsr			_Dialog
	bra			_M01				; on quitte ...

;----------------
; Alloue Buffer
;----------------
	
_Da_H01:
	move.w		d0,d1
	clr.l		d0
	move.w		d1,d0					; d0 = nb de nom 
	move.l		d0,-(a7)				; taille du handle allou
	jsr			doorsos::HeapAlloc		; Allocation
	lea			4(a7),a7
	tst.w		d0
	bne			_Da_H0

;----------------
; Erreur Mem
;----------------

	lea			err_mem,a6
	bsr			_Dialog
	bra			_M01

;----------------
; Continue
;----------------

_Da_H0:
	move.w		d0,var					; var = handle
	DEREF		d0,a6					; a6 = adresse du handle
	bsr			_Nbnom					; d0 nb d'octets allouer
	move.l		a6,a5
	subq.w		#1,d0

_Da_H1:
	clr.b		(a5)+					; on efface le buffer cmplt
	dbra		d0,_Da_H1

;====================================
; Demande la date...
;====================================

_Da_Mi0:
	lea			titre,a0
	jsr			graphlib::clr_scr2
	movem.l		d0-d6/a0-a6,-(a7)
	clr.w		d0
	clr.w		d1
	move.w		#238,d2
	move.w		#2,d3
	jsr			graphlib::horiz
	WriteStrA	#0,#2,#4,a0
	clr.w		d0
	move.w		#238,d2
	move.w		#8,d1
	jsr			graphlib::horiz
	movem.l		(a7)+,d0-d6/a0-a6


	WriteStr	#10,#25,#4,date

	bsr			_Nbnom
	move.w		d0,d7					; d7 = nb de nom dans annu
	lea			StrInput,a0
	move.w		#20,d1


	subq.w		#1,d7					; d7 = nb de nom - 1
	move.w		#40,d1					; y
	move.w		#40,d2					; x
	move.w		#5,d3					; nb carac max

	lea			nb_str,a0
	addq.l		#2,a0
	move.l		a0,pos					; petite astuce :p

	move.l		a6,-(a7)
	lea			blanc,a6
	bsr			_InputStr
	move.l		(a7)+,a6

	move.l		a0,a1					; sauve l'adresse string dans a1

	cmp.w		#$FFFF,d0				; Esc ?
	beq			_Dat_Fin				;  -> quit...
	bsr			_Adr
	add.l		#118,a0
	move.l		a0,pos					; on sauve l'adresse du 1 annif

;------------------------
; Vrification
;------------------------

	move.l		a1,a2				; a2 = adresse de la date entre
	move.l		a1,pos2				; sauve dans pos2
	move.w		#4,d5				; nb de baractre  tester = 5 (4+1)
_DatF:
	cmp.w		#2,d5
	beq			_DatF0
	cmp.b		#48,(a2)
	bcs			_DatFF				; erreur = date avec de carac non chiffre
	cmp.b		#58,(a2)
	bhi			_DatFF				;  " " " " " " " " " " " " " " " " " " "
_DatF0:
	addq.l		#1,a2
	dbra		d5,_DatF			; on recommence 5 x en evitant la 3x
	bra			_Date00				; continue

;----------------
; Erreur Syntaxe
;----------------

_DatFF:
	lea			err_date,a6
	bsr			_Dialog
	bra			_Da_Mi0

;---------------------------------
; Vrification de l'anniversaire
;---------------------------------

_Date00:
	move.l		pos,a0					; a0 = adresse du 1 annif
	move.l		pos2,a1					; a1 = adresse de la date entre

	cmp.b		(a1)+,(a0)+				; compare mois entr avec mois des noms
	bne			_Date01					; si diff. => Fete ?
	cmp.b		(a1)+,(a0)+
	beq			_Date_Ann				; 2 chiffre identique => Stockage

;---------------------------------
; Vrification de la fte
;---------------------------------

_Date01:
	move.l		pos,a0					; a0 = adresse du 1 annif
	move.l		pos2,a1					; a1 = adresse de la date entr
	add.l		#9,a0					; ...se met sur le mois de la fete
	cmp.b		(a1)+,(a0)+				; compare mois entr avec mois des noms
	bne			_Date02					; si diff. => Reteste...
	cmp.b		(a1)+,(a0)+
	beq			_Date_Fete				; si id, alors on stocke

;---------------------------------
; Reprparation du nx nom
;---------------------------------

_Date02:
	addq.l		#1,a6					; dans le buffer, on passe au suivant
	move.l		pos,a0	
	add.l		#152,a0					; nom suivant !
	move.l		a0,pos					; resauve l'adresse
	dbra		d7,_Date00				; boucle (X nb de nom)

;=============================================================
; Affichage
;=============================================================

_Dat_Aff:
	move.w		var,d0
	DEREF		d0,a0					; a0 adresse du buffer
	move.l		a0,pos					; sauve dans pos
	move.l		#-1,d1					; index du 0 nom

	bsr			_Nbnom
	subq.w		#1,d0					; nb de nom - 1

;----------------------------
; Affiche le premier
;----------------------------

_Dat_Aff_Premier:
	add.l		#1,d1					; passe au suivant
	move.l		pos,a0
	add.l		d1,a0					; adresse de l'index ds buffer		
	
	cmp.b		#1,(a0)
	beq			_Dat_Aff_Anniversaire	; anniversaire
	cmp.b		#2,(a0)
	beq			_Dat_Aff_Fete			; fete

	cmp.w		d0,d1					; si fin de buffer
	beq			_Dat_Aff_Rien			;   -> fin de recherche = rien

	bra			_Dat_Aff_Premier		; continue la recherche

;----------------------------
; Recherche infructueuse
;----------------------------

_Dat_Aff_Rien:
	lea			err_find,a6
	bsr			_Dialog
	bra			_Dat_Fin

;----------------------------
; Gestion Haut Bas
;----------------------------

_Dat_Aff_Wait:
	move.w		d1,d2					; d2 = index du dernier nom affich
	bsr			_Nbnom
	subq.w		#1,d0					; d0 = nb de nom
	move.w		d0,d3					; d3 = idem
	lea			datehelp,a6
	bsr			_idle_loop
	cmp			#264,d0					; ESC ?
	beq			_Dat_Fin
	cmp			#KEY_UP,d0				; haut ?
	beq			_Dat_Aff_Haut
	cmp			#KEY_DOWN,d0			; Bas ?
	beq			_Dat_Aff_Bas

	bra			_Dat_Aff_Wait			; sinon on attend

;--------------
; Haut
;--------------
	
_Dat_Aff_Haut:
	cmp.w		#0,d1					; si dbut de buffer
	beq			_Dat_Aff_Wait			;   -> fin de recherche = rien

	subq.l		#1,d1					; passe au suivant
	move.l		pos,a0
	add.l		d1,a0					; adresse de l'index ds buffer		
	
	cmp.b		#1,(a0)
	beq			_Dat_Aff_Anniversaire	; anniversaire
	cmp.b		#2,(a0)
	beq			_Dat_Aff_Fete			; fete

	cmp.w		#0,d1					; si dbut de buffer
	bne			_Dat_Aff_Haut			;   -> fin de recherche = rien

	move.w		d2,d1					; restaure l'index (car aucun autre)
	bra			_Dat_Aff_Wait

;--------------
; Bas
;--------------
	
_Dat_Aff_Bas:
	cmp.w		d3,d1					; si dbut de buffer
	beq			_Dat_Aff_Wait			;   -> fin de recherche = rien

	addq.l		#1,d1					; passe au suivant
	move.l		pos,a0
	add.l		d1,a0					; adresse de l'index ds buffer		
	
	cmp.b		#1,(a0)
	beq			_Dat_Aff_Anniversaire	; anniversaire
	cmp.b		#2,(a0)
	beq			_Dat_Aff_Fete			; fete

	cmp.w		d3,d1					; si dbut de buffer
	bne			_Dat_Aff_Bas			;   -> fin de recherche = rien

	move.w		d2,d1					; restaure l'index (car aucun autre)
	bra			_Dat_Aff_Wait


;---------------------------------
; Fin
;---------------------------------
	
_Dat_Fin:
	move.w		var,-(a7)
	jsr			doorsos::HeapFree
	lea			2(a7),a7
	bra			_M01

;***************************************************************
;* AJOUTER UN NOM	(F3 = 1)
;***************************************************************


;=========================
;Redimensionnement de annu
;=========================

_Ajout:
	bsr			_Adr					; retourne dans a0 l'adresse de 'annu'
	move.w		(a0),d0					; dtermine taille de 'annu'
	move.l		vatadr,a0						
	cmp			#48,d0
	bne			_A000
	move.w		#2,d0					; si 1 nom : taille = 2+152 bytes
_A000:
	move.w		d0,taille				; on sauve l'ancienne taille 
	add.w		#152,d0					; on ajoute 152 bytes au fichier
	move.w		d0,d1
	jsr			filelib::resizefile		; redimensionnement !!!
	cmp.w		d0,d1					; Reussite ?
	beq			_A000_1					;  -> oui !
_A000_0:								;  -> non !
	lea			err_mem,a6				; pas assez de memoire !
	bsr			_Dialog					; on affiche l'erreur..
	bra			_M01					; on quitte

;=========================
; Cration d'un buffer
;=========================

_A000_1:
	move.l		#152,-(a7)
	jsr			doorsos::HeapAlloc		; buffer allou de 152 bytes...
	lea			4(a7),a7
	tst.w		d0						; assez de mem ?
	bne			_A000_2					;   -> oui !

;-----------
; Mem Error
;-----------					
									
	move.w		taille,d0				; redimensionnement
	cmp.w		#2,d0					; 1 seul nom ?
	bne			_A000_11
	move.w		#48,d0

_A000_11:
	jsr			filelib::resizefile		; on redimensionne la taille
	bra			_A000_0					; on cre un erreur mmoire

;-----------
; Ok
;-----------

_A000_2:
	move.w		d0,-(a7)				; handle sur le stack
	DEREF	d0,a1						; adresse du buffer dans a1
	move.l		a1,pos					; on sauve l'adresse du handle
	move.w		#151,d1
_A000_3:								; on efface la totalit du buffer
	clr.b		(a1)+					; pour eviter les bytes parasites
	dbra		d1,_A000_3

	move.l		pos,a1					; restauration de a1
	
	
	lea			titre,a0
	jsr			graphlib::clr_scr2
	movem.l		d0-d6/a0-a6,-(a7)
	clr.w		d0
	clr.w		d1
	move.w		#238,d2
	move.w		#2,d3
	jsr			graphlib::horiz
	WriteStrA	#0,#2,#4,a0
	clr.w		d0
	move.w		#238,d2
	move.w		#8,d1
	jsr			graphlib::horiz
	movem.l		(a7)+,d0-d6/a0-a6


;=========================
;Nom
;=========================

_A001:
	lea			form1,a6
	move.w		#20,d1					; x
	move.w		#38,d2					; y
	move.w		#23,d3					; nb carac max ...
	move.l		pos,pos2
	bsr			_InputStr				; demande le nom ...
	move.l		pos2,pos
	cmp.w		#$FFFF,d0				; Esc ?
	beq			_A09					;  -> si oui on quitte...
	move.l		pos,a1					; on restaure l'adresse du handle
_A01:
	move.b		(a0)+,(a1)+				; a0 = adr. de la chaine
	dbra		d3,_A01					; a1 = adr. du buffer o stocker nom
	move.l		a1,pos	

	cmp.w		#KEY_UP,d0				; si on va vers le bas -> adresse
	bne			_A002
	sub.l		#24,pos 				; sinon on recommence
	bra			_A001

;=========================
;Adresse
;=========================

_A002:

	lea			form2,a6
	move.w		#30,d1
	move.w		#48,d2
	move.w		#30,d3
	move.l		pos,pos2
	bsr			_InputStr				; demande le nom ...
	move.l		pos2,pos
	cmp.w		#$FFFF,d0
	beq			_A09
	move.l		pos,a1
_A02:
	move.b		(a0)+,(a1)+
	dbra		d3,_A02	
	move.l		a1,pos
	
	cmp.w		#KEY_UP,d0
	bne			_A003
	sub.l		#31+24,pos
	bra			_A001

;=========================
;Ville
;=========================

_A003:
	lea			form3,a6
	move.w		#30,d1
	move.w		#56,d2
	move.w		#27,d3
	move.l		pos,pos2
	bsr			_InputStr				; demande le nom ...
	move.l		pos2,pos
	cmp.w		#$FFFF,d0
	beq			_A09
	move.l		pos,a1
_A03:
	move.b		(a0)+,(a1)+
	dbra		d3,_A03		
	move.l		a1,pos
	
	cmp.w		#KEY_UP,d0
	bne			_A004
	sub.l		#31+28,pos
	bra			_A002
		

;=========================
;Telephone
;=========================

_A004:
	lea			form4,a6
	move.w		#30,d1
	move.w		#70,d2
	move.w		#14,d3
	move.l		pos,pos2
	bsr			_InputStr				; demande le nom ...
	move.l		pos2,pos
	cmp.w		#$FFFF,d0
	beq			_A09
	move.l		pos,a1
_A04:
	move.b		(a0)+,(a1)+
	dbra		d3,_A04	
	move.l		a1,pos
	
	cmp.w		#KEY_UP,d0
	bne			_A005
	sub.l		#28+15,pos
	bra			_A003
			

;=========================
;Portable
;=========================

_A005:
	lea			form5,a6
	move.w		#30,d1
	move.w		#78,d2
	move.w		#14,d3
	move.l		pos,pos2
	bsr			_InputStr				; demande le nom ...
	move.l		pos2,pos
	cmp.w		#$FFFF,d0
	beq			_A09
	move.l		pos,a1
_A05:
	move.b		(a0)+,(a1)+
	dbra		d3,_A05	
	move.l		a1,pos
	
	cmp.w		#KEY_UP,d0
	bne			_A006
	sub.l		#15+15,pos
	bra			_A004
	

;=========================
;Anniversaire
;=========================

_A006:
	lea			form6,a6
	move.w		#40,d1
	move.w		#86,d2
	move.w		#8,d3
	move.l		pos,pos2
	bsr			_InputStr				; demande le nom ...
	move.l		pos2,pos
	cmp.w		#$FFFF,d0
	beq			_A09
	move.l		pos,a1
_A06:
	move.b		(a0)+,(a1)+
	dbra		d3,_A06	
	move.l		a1,pos

	cmp.w		#KEY_UP,d0
	bne			_A007
	sub.l		#15+9,pos
	bra			_A005

					
;=========================
;Fete
;=========================

_A007:
	lea			form7,a6
	move.w		#40,d1
	move.w		#94,d2
	move.w		#5,d3
	move.l		pos,pos2
	bsr			_InputStr				; demande le nom ...
	move.l		pos2,pos
	cmp.w		#$FFFF,d0
	beq			_A09
	move.l		pos,a1
_A07:
	move.b		(a0)+,(a1)+
	dbra		d3,_A07	
	move.l		a1,pos
	
	cmp.w		#KEY_UP,d0
	bne			_A008
	sub.l		#9+6,pos
	bra			_A006
			

;=========================
;Email
;=========================

_A008
	lea			form8,a6
	move.w		#30,d1
	move.w		#106,d2
	move.w		#23,d3
	move.l		pos,pos2
	bsr			_InputStr				; demande le nom ...
	move.l		pos2,pos
	cmp.w		#$FFFF,d0
	beq			_A09
	move.l		pos,a1
_A08:
	move.b		(a0)+,(a1)+
	dbra		d3,_A08
	move.l		a1,pos

	cmp.w		#KEY_UP,d0
	bne			_A009
	sub.l		#6+24,pos
	bra			_A007

_A009:
	cmp.w		#KEY_DOWN,d0
	bne			_A010
	sub.l		#24,pos
	bra			_A008

;=========================
;Sauvegarde ?
;=========================

_A010:
	lea			sauve,a6
	bsr			_Dialog					; confirmation ...
	cmp			#13,d0					; enter = on sauve
	bne			_A09

;=========================
;On sauve !!!!
;=========================
	
	sub.l		#152,a1
	bsr			_Range					; on classe le dernier nom entr
	move.w		(a7)+,d1				; RAPPEL : le handle est sur le stack !!
	move.w		d0,-(a7)				; on sauve le numro du nom

	move.w		d1,-(a7)
	jsr			doorsos::HeapFree		; libre le buffer
	lea			2(a7),a7

	move.w		(a7)+,d0				; on restaure le numro du nom
	bra			_Aff0					; on affiche le nom

;=========================
;On ne sauve pas !!!
;=========================
	
_A09:									; RAPPEL : le handle est sur le stack !!
	jsr			doorsos::HeapFree		; libre le buffer
	lea			2(a7),a7

	bsr			_Adr					; retourne dans a0 l'adresse de 'annu'
	move.w		(a0),d0					; dtermine taille de 'annu'
	cmp			#152+2,d0				; 1 seul nom ?
	bne			_A10
	move.w		#152+48,d0			
	move.w		d0,taille

_A10:
	move.l		vatadr,a0
	sub.w		#152,d0					; sinon on soustrait 152 bytes
	jsr			filelib::resizefile

	bra			_M01

;***************************************************************
;* MODIFIER UN NOM	(F3 = 2)
;***************************************************************

_Modif:
	move.w		#1,d3					; elment slctionn au dbut...
	bsr			_Liste

	cmp.w		#0,d0					; y a t il eu ESC ?
	beq			_M01					;      si oui, quit...

	clr.l		d3
	move.w		d0,d3					; d3 = index du nom

	lea			titre,a0
	jsr			graphlib::clr_scr2
	movem.l		d0-d6/a0-a6,-(a7)
	clr.w		d0
	clr.w		d1
	move.w		#238,d2
	move.w		#2,d3
	jsr			graphlib::horiz
	WriteStrA	#0,#2,#4,a0
	clr.w		d0
	move.w		#238,d2
	move.w		#8,d1
	jsr			graphlib::horiz
	movem.l		(a7)+,d0-d6/a0-a6

;=========================
; Cration d'un buffer
;=========================

	move.l		#152,-(a7)
	jsr			doorsos::HeapAlloc		; buffer allou de 152 bytes...
	lea			4(a7),a7
	tst.w		d0						; assez de mem ?
	bne			_Modif0					;   -> oui !

;-----------
; Mem Error
;-----------					
	
	lea			err_mem,a6				; pas assez de memoire !
	bsr			_Dialog					; on affiche l'erreur..
	bra			_M01					; on quitte

;=========================
; Copie le nom ds handle
;=========================

_Modif0:
	move.w		d0,var					; on sauve le handle dans 'var'
	DEREF		d0,a1					; a1 = adresse du handle
	move.l		a1,pos					; sauve dans 'pos' adr. du handle
	move.w		#151,d0

	move.l		d3,-(a7)				; sauve index sur stack pour ranger

	subq.w		#1,d3
	mulu		#152,d3
	addq.w		#2,d3
	bsr			_Adr
	add.l		d3,a0					; a0 = adresse du nom en mmoire
	move.l		a0,pos2		

_Modif01:
	move.b		(a0)+,(a1)+				; copiage brut de 152 bytes
	dbra		d0,_Modif01

	move.l		pos,a1

;=========================
; Affichage du handle
;=========================

	WriteStrA	#20,#38,#4,a1			; Nom
	move.l		pos,a1
	add.l		#24,a1
	move.l		a1,pos

	WriteStrA	#30,#48,#4,a1			; Adresse
	move.l		pos,a1
	add.l		#31,a1
	move.l		a1,pos

	WriteStrA	#30,#56,#4,a1			; Ville
	move.l		pos,a1
	add.l		#28,a1
	move.l		a1,pos
	
	WriteStrA	#30,#70,#4,a1			; Telephone
	move.l		pos,a1
	add.l		#15,a1
	move.l		a1,pos
	
	WriteStrA	#30,#78,#4,a1			; Portable
	move.l		pos,a1
	add.l		#15,a1
	move.l		a1,pos
	
	WriteStrA	#40,#86,#4,a1			; Annif
	move.l		pos,a1
	add.l		#9,a1
	move.l		a1,pos
	
	WriteStrA	#40,#94,#4,a1			; Fete
	move.l		pos,a1
	add.l		#6,a1
	move.l		a1,pos

	WriteStrA	#30,#106,#4,a1			; Email

;=========================
;Preparation
;=========================

	move.l		pos,a1
	sub.l		#128,a1
	move.l		a1,pos

;=========================
;Nom
;=========================

_Mo001:
	lea			form1,a6
	move.w		#20,d1					; x
	move.w		#38,d2					; y
	move.w		#23,d3					; nb carac max ...
	move.l		pos,pos2
	bsr			_InputStr				; demande le nom ...
	move.l		pos2,pos
	cmp.w		#$FFFF,d0				; Esc ?
	beq			_Mo09					;  -> si oui on quitte...
	move.l		pos,a1					; on restaure l'adresse du handle
_Mo01:
	move.b		(a0)+,(a1)+				; a0 = adr. de la chaine
	dbra		d3,_Mo01				; a1 = adr. du buffer o stocker nom
	move.l		a1,pos	

	cmp.w		#KEY_UP,d0				; si on va vers le bas -> adresse
	bne			_Mo002
	sub.l		#24,pos					; sinon on recommence
	bra			_Mo001

;=========================
;Adresse
;=========================

_Mo002:
	lea			form2,a6
	move.w		#30,d1
	move.w		#48,d2
	move.w		#30,d3
	move.l		pos,pos2
	bsr			_InputStr				; demande le nom ...
	move.l		pos2,pos
	cmp.w		#$FFFF,d0
	beq			_Mo09
	move.l		pos,a1
_Mo02:
	move.b		(a0)+,(a1)+
	dbra		d3,_Mo02	
	move.l		a1,pos
	
	cmp.w		#KEY_UP,d0
	bne			_Mo003
	sub.l		#31+24,pos
	bra			_Mo001

;=========================
;Ville
;=========================

_Mo003:
	lea			form3,a6
	move.w		#30,d1
	move.w		#56,d2
	move.w		#27,d3
	move.l		pos,pos2
	bsr			_InputStr				; demande le nom ...
	move.l		pos2,pos
	cmp.w		#$FFFF,d0
	beq			_Mo09
	move.l		pos,a1
_Mo03:
	move.b		(a0)+,(a1)+
	dbra		d3,_Mo03		
	move.l		a1,pos
	
	cmp.w		#KEY_UP,d0
	bne			_Mo004
	sub.l		#31+28,pos
	bra			_Mo002
		

;=========================
;Telephone
;=========================

_Mo004:
	lea			form4,a6
	move.w		#30,d1
	move.w		#70,d2
	move.w		#14,d3
	move.l		pos,pos2
	bsr			_InputStr				; demande le nom ...
	move.l		pos2,pos
	cmp.w		#$FFFF,d0
	beq			_Mo09
	move.l		pos,a1
_Mo04:
	move.b		(a0)+,(a1)+
	dbra		d3,_Mo04	
	move.l		a1,pos
	
	cmp.w		#KEY_UP,d0
	bne			_Mo005
	sub.l		#28+15,pos
	bra			_Mo003
			

;=========================
;Portable
;=========================

_Mo005:
	lea			form5,a6
	move.w		#30,d1
	move.w		#78,d2
	move.w		#14,d3
	move.l		pos,pos2
	bsr			_InputStr				; demande le nom ...
	move.l		pos2,pos
	cmp.w		#$FFFF,d0
	beq			_Mo09
	move.l		pos,a1
_Mo05:
	move.b		(a0)+,(a1)+
	dbra		d3,_Mo05	
	move.l		a1,pos
	
	cmp.w		#KEY_UP,d0
	bne			_Mo006
	sub.l		#15+15,pos
	bra			_Mo004

;=========================
;Anniversaire
;=========================

_Mo006:
	lea			form6,a6
	move.w		#40,d1
	move.w		#86,d2
	move.w		#8,d3
	move.l		pos,pos2
	bsr			_InputStr				; demande le nom ...
	move.l		pos2,pos
	cmp.w		#$FFFF,d0
	beq			_Mo09
	move.l		pos,a1
_Mo06:
	move.b		(a0)+,(a1)+
	dbra		d3,_Mo06	
	move.l		a1,pos

	cmp.w		#KEY_UP,d0
	bne			_Mo007
	sub.l		#15+9,pos
	bra			_Mo005

					
;=========================
;Fete
;=========================

_Mo007:
	lea			form7,a6
	move.w		#40,d1
	move.w		#94,d2
	move.w		#5,d3
	move.l		pos,pos2
	bsr			_InputStr				; demande le nom ...
	move.l		pos2,pos
	cmp.w		#$FFFF,d0
	beq			_Mo09
	move.l		pos,a1
_Mo07:
	move.b		(a0)+,(a1)+
	dbra		d3,_Mo07	
	move.l		a1,pos
	
	cmp.w		#KEY_UP,d0
	bne			_Mo008
	sub.l		#9+6,pos
	bra			_Mo006
			

;=========================
;Email
;=========================

_Mo008
	lea			form8,a6
	move.w		#30,d1
	move.w		#106,d2
	move.w		#23,d3
	move.l		pos,pos2
	bsr			_InputStr				; demande le nom ...
	move.l		pos2,pos
	cmp.w		#$FFFF,d0
	beq			_Mo09
	move.l		pos,a1
_Mo08:
	move.b		(a0)+,(a1)+
	dbra		d3,_Mo08
	move.l		a1,pos

	cmp.w		#KEY_UP,d0
	bne			_Mo009
	sub.l		#6+24,pos
	bra			_Mo007

_Mo009:
	cmp.w		#KEY_DOWN,d0
	bne			_Mo010
	sub.l		#24,pos
	bra			_Mo008


;=========================
;Sauvegarde ?
;=========================

_Mo010:
	lea			sauve,a6
	bsr			_Dialog					; confirmation ...
	cmp			#13,d0					; enter = on sauve
	bne			_Mo09					;  non -> esc...

;=======================
;On sauve !!!!
;=======================

;---------------------
; Efface l'ancien nom
;---------------------

	move.l		(a7)+,d1				; d1 = index du nom selectionn
	bsr			_Nbnom					; retourne en d0 le nb de nom
	cmp.w		#1,d0					; Un seul nom ?
	beq			_Mod_Cla
	cmp.w		d0,d1					; le dernier nom est  supprimer ??
	beq			_Mod_Cla

_MoEff01:
	bsr			_Adr
	move.w		(a0),d0					; d0 = taille de annu
	move.l		a0,a2					; 
	add.l		d0,a2					: a2 = adresse de fin de fichier 'annu'
	subq.w		#1,d1					; d1 = n du nom selectionn
	mulu.w		#152,d1
	addq.w		#2,d1
	add.l		d1,a0					; a0 = adresse du nom a supprimer
	move.l		a0,a1
	add.l		#152,a1					; a1 = adresse du nom suivant
	sub.l		a1,a2
	move.l		a2,d2					; d2 = nb d'octet  dplacer de 152
	subq.l		#1,d2					;   bytes vers la gauche
_MoEff001:
	move.b		(a1)+,(a0)+				; on translate...
	dbra		d2,_MoEff001

;----------------------
; Range le nouveau nom
;----------------------

_Mod_Cla:
	move.l		pos,a1
	sub.l		#152,a1					; a1 = adresse du nom ds buffer
	bsr			_Range					; d0 = nom slectionn

;----------------------
; Fin de sauvegarde
;----------------------

_Mod_Fin:
	move.w		var,-(a7)				; var = handle
	move.w		d0,var
	jsr			doorsos::HeapFree		; libre le buffer
	lea			2(a7),a7

	move.w		var,d0					; on restaure le numro du nom
	bra			_Aff0					; on affiche le nom

;=========================
;On ne sauve pas !!!
;=========================

_Mo09:
	move.l		(a7)+,d1				; (juste pour retablir le stack)
	move.w		var,-(a7)				; n du buffer
	jsr			doorsos::HeapFree		; libre le buffer
	lea			2(a7),a7				; 2 

	bra			_M01

;***********************************************************************
;* SUPPRIMER UN NOM	(F3 = 3)
;***********************************************************************

_Retire:
	move.w		#1,d3					; elment slctionn au dbut...
	bsr			_Liste					; d0 le nom selectionn

	cmp.w		#0,d0					; y a t il eu ESC ?
	beq			_M01					;      si oui, quit...

	move.w		d0,d1
	lea			confirm,a6
	bsr			_Dialog					; retourne d0 = touche frapp
	cmp			#13,d0					; confirmation ?
	bne			_M01					;      si non, quit...

	bsr			_Nbnom					; retourne en d0 le nb de nom
	cmp.w		#1,d0					; Un seul nom ?
	beq			_R00
	
	cmp.w		d0,d1					; le dernier nom est  supprimer
	bne			_R01

;====================
; Le dernier ...
;====================

_R02:
	bsr			_Adr					; retourne a0 = adresse de 'annu'
	move.w		(a0),d0					; d0 = taille
	sub.w		#152,d0
	move.l		vatadr,a0							
	jsr			filelib::resizefile
	bra			_M01

;==========================
; 1 seul nom en mem
;==========================

_R00:
	move.l		vatadr,a0					
	move.w		#48,d0					; taille min = 48 bytes
	jsr			filelib::resizefile
	bra			_M01

;==========================
; Supprimer (autres cas)
;==========================

_R01:
	bsr			_Adr
	move.w		(a0),d0					; d0 = taille de annu
	move.l		a0,a2					; 
	add.l		d0,a2					: a2 = adresse de fin de fichier 'annu'

	subq.w		#1,d1					; d1 = n du nom selectionn
	mulu.w		#152,d1
	addq.w		#2,d1
	add.l		d1,a0					; a0 = adresse du nom a supprimer
	move.l		a0,a1
	add.l		#152,a1					; a1 = adresse du nom suivant

	sub.l		a1,a2
	move.l		a2,d2					; d2 = nb d'octet  dplacer de 152
	subq.l		#1,d2					;   bytes vers la gauche
_R001:
	move.b		(a1)+,(a0)+				; on translate...
	dbra		d2,_R001

	bra			_R02					; reduction de la taille 'annu'


;***********************************************************************
;* COPYRIGHT ( F4 )
;***********************************************************************

_About:
	lea			titre,a0
	jsr			graphlib::clr_scr2
	movem.l		d0-d6/a0-a6,-(a7)
	clr.w		d0
	clr.w		d1
	move.w		#238,d2
	move.w		#2,d3
	jsr			graphlib::horiz
	WriteStrA	#0,#2,#4,a0
	clr.w		d0
	move.w		#238,d2
	move.w		#8,d1
	jsr			graphlib::horiz
	movem.l		(a7)+,d0-d6/a0-a6


	move.w		#195,d0
	move.w		#35,d1
	lea			image2,a0
	clr.b		d3
	jsr			graphlib::put_sprite_mask

	SetFont		#2
	WriteStr	#20,#40,#4,copyr1
	SetFont		#1
	WriteStr	#40,#60,#4,copyr2
	SetFont		#0
	WriteStr	#20,#75,#4,copyr3
	WriteStr	#20,#83,#4,copyr4
	bra			_MainKey


;***********************************************************************
;*	C'EST LA FIN ...									
;***********************************************************************

_exit:
	lea			quit,a6
	bsr			_Dialog
	cmp.w		#13,d0
	bne			_M01

;===================
;= Histoire du ZIP
;===================

	movem.l		d0-d7/a0-a6,-(a7)
	move.l		vatadr,a0				; adresse de 'annu' en Vat
	jsr			ziplib::iscomp			; est il dja zipper ???
	tst.w		d0
	beq			_exit2
	clr.b		d0						; aucun commentaires
	jsr			ziplib::zipfile			; on zippe 'annu'

	move.w		12(a0),d0				; handle du fichier annu
	DEREF		d0,a1
	move.w		(a1),d0					; taille du fichier annu
	clr.l		d1
	move.w		d0,d1
	add.l		d1,a1
	subq.l		#3,a1

	cmp.b		#$5A,(a1)+				; ? "Z"
	bne			_exit2
	cmp.b		#$49,(a1)+				; ? "I"
	bne			_exit2
	cmp.b		#$50,(a1)+				; ? "P"
	bne			_exit2
	subq.l		#3,a1

	clr.l		d6
	move.b		(a1),d6
	move.b		#$53,(a1)+				; -> "S"
	move.b		#$41,(a1)+				; -> "A"
	move.b		#$56,(a1)+				; -> "V"

_exit2:
	movem.l		(a7)+,d0-d7/a0-a6

;===================
;= Histoire de arch
;===================

_exit_archive:
	movem.l		d0-d7/a0-a6,-(a7)
	tst.w		archive
	beq			_exit_arch

	move.w		#1,d1					; cherche le 1 fichier 'annu'
	lea			name2,a0
	jsr			filelib::search			; d0 = handle du fold et a0 = adr de 'annu'
										;			en VAT
	movem.l		d0/a0,-(a7)
	DEREF		d0,a1							; a1 = adresse du deb vat
	movem.l		(a7)+,d0/a0

	sub.l		a1,a0
	move.w		a0,d1							; d1 = adr rel

	move.w		d1,-(a7)						; adresse relative du fich en FAT
	move.w		d0,-(a7)						; folder handle
	clr.l		-(a7)
	jsr         doorsos::EM_moveSymToExtMem      ; Archive !
	addq.l		#8,a7

_exit_arch:
	movem.l		(a7)+,d0-d7/a0-a6

	rts

;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************

;***************************************************************
;* Routine Stockant les annifs des personne
;*	INPUT : a6 = adresse de stockage dans le handle
;***************************************************************

_Date_Ann:
	move.l		a6,-(a7)
	move.b		#1,(a6)+
	addq.w		#1,nbitem
	move.l		(a7)+,a6
	bra			_Date01

;***************************************************************
;* Routine Stockant les annifs des personne
;*	INPUT : a6 = adresse de stockage dans le handle
;***************************************************************

_Date_Fete:
	move.l		a6,-(a7)
	move.b		#2,(a6)+
	move.l		(a7)+,a6
	addq.w		#1,nbitem
	bra			_Date02

;***************************************************************
;* Routine d'Affichage d'un Anniversaire
;* INPUT = d1 : Index du nom  afficher - 1
;***************************************************************

_Dat_Aff_Anniversaire:
	movem.l		d0-d7/a0-a6,-(a7)
	lea			titre,a0
	jsr			graphlib::clr_scr2
	movem.l		d0-d6/a0-a6,-(a7)
	clr.w		d0
	clr.w		d1
	move.w		#238,d2
	move.w		#2,d3
	jsr			graphlib::horiz
	WriteStrA	#0,#2,#4,a0
	clr.w		d0
	move.w		#238,d2
	move.w		#8,d1
	jsr			graphlib::horiz
	movem.l		(a7)+,d0-d6/a0-a6

	pea			datehelp
	jsr			doorsos::ST_showHelp	; on affiche l'aide
	lea			4(a7),a7
	movem.l		(a7),d0-d7/a0-a6


	bsr			_Adr						; a0 = adresse du dbut de 'annu'
	addq.l		#2,a0
	move.w		#20,d0						; x
	mulu		#152,d1
	add.l		d1,a0						; a0 = adr du nom
	lea			StrInput,a1					; a1 = adresse de date entre

;--------------------------
; Affiche le nom
;--------------------------

	jsr			graphlib::getlength
	movem.l		d0/d1/d3/a0/a1,-(a7)
	WriteStrA	d0,#40,#4,a0			
	movem.l		(a7)+,d0/d1/d3/a0/a1
	add.l		d3,d0						; d3 = x du fin du nom

;--------------------------
; Affiche la date
;--------------------------

	add.l		#113,a0						; a0 = adresse de l'annif
	jsr			graphlib::getlength
	move.w		d3,d7
	movem.l		d0/d1/d7/a0/a1,-(a7)
	add.l		#65,d0
	WriteStrA	d0,#40,#4,a0				
	movem.l		(a7)+,d0/d1/d7/a0/a1

;--------------------------
; Extrait l'anne naissance
; -> d4
;--------------------------

	add.l		#6,a0					; a0 = adresse de l'ann de naissance
	clr.w		d4
	clr.w		d2
	move.b		(a0)+,d4
	move.b		(a0)+,d2				; on prend les 2 carac de l'anne
	sub.w		#48,d4
	sub.w		#48,d2					; carac -> nb
	mulu		#10,d4
	add.w		d2,d4					; d4 = anne de naissance

;--------------------------
; Extrait l'anne actuelle
; -> d3
;--------------------------

	addq.l		#3,a1					; a1 = adresse de l'anne date entre
	clr.w		d3
	clr.w		d2
	move.b		(a1)+,d3
	move.b		(a1)+,d2				; on prend les 2 carac de l'anne
	subq.l		#2,a1					; on remet en place l'adresse
	sub.w		#48,d3	
	sub.w		#48,d2					; carac -> nb
	mulu		#10,d3
	add.w		d2,d3					; d3 = anne actuelle

;--------------------------
; Calcul de l'ge...
;--------------------------

	cmp.w		d4,d3
	bhi			_DAA00
	add.w		#100,d3
_DAA00:
	sub.w		d4,d3
	movem.l		d0/d1/d7/a1,-(a7)
	Nb_Str		d3,format,nb_str
	movem.l		(a7)+,d0/d1/d7/a1

;--------------------------
; Affichage de l'ge
;--------------------------

	movem.l		d0/d1/d7/a1,-(a7)
	add.l		#25,d0
	WriteStr	d0,#40,#4,nb_str		
	movem.l		(a7)+,d0/d1/d7/a1

;--------------------------
; Affiche l'anne actuelle
;--------------------------
	
	move.l		a1,a0
	jsr			graphlib::getlength
	sub.w		d3,d7
	movem.w		d0/d1,-(a7)
	add.w		#65,d7
	add.w		d7,d0
	WriteStrA	d0,#40,#4,a1			
	movem.w		(a7)+,d0/d1

;--------------------------
; Affiche le reste
;--------------------------

	movem.w		d0/d1,-(a7)
	WriteStr	d0,#40,#4,annif1			; " aura "
	movem.w		(a7)+,d0/d1
	add.w		#40,d0
	movem.w		d0/d1,-(a7)
	WriteStr	d0,#40,#4,annif2			; " ans le "
	movem.w		(a7)+,d0/d1
	
	movem.l		(a7)+,d0-d7/a0-a6

	bsr			_Dat_Aff_Autre

	bra			_Dat_Aff_Wait
	
;***************************************************************
;* Routine d'Affichage d'une Fete
;* INPUT = d1 : Index du nom  afficher - 1
;***************************************************************

_Dat_Aff_Fete:

	movem.l		d0-d7/a0-a6,-(a7)
	lea			titre,a0
	jsr			graphlib::clr_scr2
	movem.l		d0-d6/a0-a6,-(a7)
	clr.w		d0
	clr.w		d1
	move.w		#238,d2
	move.w		#2,d3
	jsr			graphlib::horiz
	WriteStrA	#0,#2,#4,a0
	clr.w		d0
	move.w		#238,d2
	move.w		#8,d1
	jsr			graphlib::horiz
	movem.l		(a7)+,d0-d6/a0-a6

	pea			datehelp
	jsr			doorsos::ST_showHelp	; on affiche l'aide
	lea			4(a7),a7
	movem.l		(a7),d0-d7/a0-a6

	bsr			_Adr						; a0 = adresse du dbut de 'annu'
	addq.l		#2,a0
	move.w		#20,d0						; x
	mulu		#152,d1
	add.l		d1,a0						; a0 = adr du nom
	lea			StrInput,a1					; a1 = adresse de date entre

;--------------------------
; Affiche le nom
;--------------------------

	jsr			graphlib::getlength
	movem.l		d0/d1/d3/a0/a1,-(a7)
	WriteStrA	d0,#40,#4,a0			
	movem.l		(a7)+,d0/d1/d3/a0/a1
	add.l		d3,d0						; d0 = x du fin du nom

;--------------------------
; Affiche la date
;--------------------------

	add.l		#122,a0						; a0 = adresse de la fete
	jsr			graphlib::getlength
	move.w		d3,d7
	movem.l		d0/d1/d7/a0/a1,-(a7)
	add.l		#55,d0
	WriteStrA	d0,#40,#4,a0				
	movem.l		(a7)+,d0/d1/d7/a0/a1

;--------------------------
; Affiche le reste
;--------------------------

	movem.w		d0/d1,-(a7)
	WriteStr	d0,#40,#4,fete1				; " aura sa fete le"
	movem.w		(a7)+,d0/d1

	movem.l		(a7)+,d0-d7/a0-a6
	
	bsr			_Dat_Aff_Autre

	bra			_Dat_Aff_Wait

;***************************************************************
;* Routine Affichage du reste dans recherche anniversaire
;* INPUT = d1 index du nom  afficher
;***************************************************************

_Dat_Aff_Autre:

	movem.l		d0-d7/a0-a6,-(a7)

;===============================
; Affiche nb de nom trouv
;===============================

	Nb_Str		nbitem,format,nb_str
	clr.w		d5
	WriteStr	d5,#116,#0,nb_str
	lea			nb_str,a0
	jsr			graphlib::getlength
	add.w		d3,d5
	WriteStr	d5,#116,#0,listdate


	movem.l		(a7),d0-d7/a0-a6			; simple restauration

	bsr			_Adr						; a0 = adresse du dbut de 'annu'
	addq.l		#2,a0
	mulu		#152,d1
	add.l		d1,a0						; a0 = adr du nom


	add.l		#24,a0						; nom (saut)

	move.l		a0,-(a7)
	WriteStrA	#30,#48,#4,a0				; Adresse
	move.l		(a7)+,a0
	add.l		#31,a0

	move.l		a0,-(a7)
	WriteStrA	#30,#56,#4,a0				; Ville
	move.l		(a7)+,a0
	add.l		#28,a0
	
	move.l		a0,-(a7)
	WriteStrA	#30,#70,#4,a0				; Telephone
	move.l		(a7)+,a0
	add.l		#15,a0
	
	move.l		a0,-(a7)
	WriteStrA	#30,#78,#4,a0				; Portable
	move.l		(a7)+,a0
	add.l		#15,a0
	
	add.l		#15,a0						; anniver + fete (saut)
	
	WriteStrA	#30,#106,#4,a0				; Email

	movem.l		(a7)+,d0-d7/a0-a6

	rts

;***************************************************************
;* Routine rangeant la liste des nom par odre alphabtique
;* retourne en d0 l'lment selectionn
;* INPUT : a1 = l'adresse du buffer de stockage
;***************************************************************

_Range:
	movem.l		d1-d2/a0-a2,-(a7)
	bsr			_Adr					; a0 = adresse de 'annu'
	addq.l		#2,a0					; a0 = adresse du 1 nom
	bsr			_Nbnom					; d0 = nb de nom au totale
	move.w		d0,d2
	subq.w		#1,d2
	tst.w		d2						; d2 = nb de nom dj entr en memoire
	beq			_Ran301					; si aucun nom entr en mmoire, on 
										; stock direct le nom sans classement
	mulu		#152,d0
	sub.w		#152*2,d0				; d0 = adr relative du dernier nom en mem
	add.l		d0,a0					; a0 = adresse du dernier nom entr

;------------
; on compare
;------------

_Ran00:
	bsr			_Compare				; compare le buffer et un nom en mmoire
	tst.w		d0						; si = 0 alors buffer < nom
	bne			_Ran30					; sinon on copie le buffer en memoire

;-------------
; buff < nom
;-------------

	move.w		#151,d1					; nb de bytes  dplacer
	move.l		a0,a2					; a0 = adresse du nom  deplacer
	add.l		#152,a2					; a2 = adresse o dplacer le nom
_Ran02:
	move.b		(a0)+,(a2)+				; on dplace vers le bas le nom
	dbra		d1,_Ran02

	sub.l		#152,a0
	subq.w		#1,d2					; vient-on de dplacer le 1 nom ?
	tst.w		d2
	beq			_Ran301					; oui => copie buffer en 1 position
	sub.l		#152,a0					; a0 adresse du nom suivant  dplacer
	bra			_Ran00

;-------------
; buff >= nom
;-------------

_Ran30:
	add.l		#152,a0
_Ran301:
	move.w		#151,d1					; nb de bytes du nouveau nom
_Ran31:
	move.b		(a1)+,(a0)+				; on copie le buffer en mmoire
	dbra		d1,_Ran31

	move.l		a0,d0
	bsr			_Adr
	sub.l		a0,d0
	subq.l		#2,d0
	divu		#152,d0					; d0 = n nom ajout dans la liste

	movem.l		(a7)+,d1-d2/a0-a2
	rts

;***************************************************************
;* Routine determinant  partir de a0 et a1 (adresses de 2
;* chaines de carac) si la 1 chaine est alphabtiquement plus 
;* grande que la 2
;* Retourne  d0.w = 0 si str1 > buffer
;*				  = 1 sinon
;***************************************************************

_Compare:
	movem.l		a0-a1,-(a7)

	move.w		#1,d0
_Com00:
	tst.b		(a0)					; fin de la 1 str ?
	beq			_Com20
	tst.b		(a1)					; fin de la str du buffer?
	beq			_Com01

	cmp.b		(a0)+,(a1)+				; buffer < str1 ?
	bcs			_Com01
	subq.l		#1,a0
	subq.l		#1,a1
	cmp.b		(a0)+,(a1)+				; buffer = str1 ?
	beq			_Com00					;  => on teste la lettre suivante
	bra			_Com20					; sinon on quitte
_Com01:
	clr.w		d0
_Com20:
	movem.l		(a7)+,a0-a1
	rts

;***************************************************************
;* Routine dessinant une boite de dialog grace  une structure
;* point par a6 
;* retourne en d0 le code de la dernire touche frapp
;***************************************************************

_Dialog:
	movem.l		d1-d3/a0-a1,-(a7)
			
	move.w		#65,d0
	move.w		#50,d1
	move.w		#100,d2
	move.w		#30,d3
	move.l		(a6),a0
	move.l		4(a6),a1
	jsr			graphlib::box

	add.w		#10,d0
	add.w		#17,d1
	WriteStrA	d0,d1,#4,a1
	lea			blanc,a6
	bsr			_idle_loop

	movem.l		(a7)+,d1-d3/a0-a1
	rts

;*************************************************************************
;*  Routine retournant en d0 le nombre de noms contenu par 'annu'		 *	
;*************************************************************************

_Nbnom:
	move.l		a0,-(a7)
	bsr			_Adr					; retourne dans a0 l'adresse de 'annu'
	clr.l		d0
	move.w		(a0),d0					; dtermine taille de 'annu'
	move.w		d0,taille				; sauve la taille
	sub.w		#2,d0					
	divu.w		#152,d0					; divise par 152 (car 1 nom = 152 bytes)
	move.l		(a7)+,a0
	rts

;*************************************************************************
;*  Routine retournant en a0 l'adresse rel de 'annu' grace 			 *	
;*	l'adresse en VAT													 *
;*************************************************************************

_Adr:
	move.l		d6,-(a7)

	move.l		vatadr,a0				; stocke dans a0 l'adresse 'annu' en VAT					; 
	move.w		12(a0),d6				; place le buffer de annu dans d6
	doorsos::DEREF	d6,a0				; trouve l'adresse reelle de 'annu' en a0

	move.l		(a7)+,d6
	rts

;*************************************************************************
;*  Routine demandant une chaine de caractre d'une taille spcifi		 *	
;*	input : d1 = X					output : d0 = $FFFF	si esc			 *
;*			d2 = Y														 *
;*			d3 = max carac												 *
;*			pos = adresse de stockage								   	 *
;*			a6 = adresse du commentaire									 *
;*************************************************************************

_InputStr:
	movem.l	d1-d7/a1,-(a7)

;==================================
; Effacement de la InputStr
;==================================

	lea			StrInput,a1
	move.w		#29,d4
_II:
	clr.b		(a1)+
	dbra		d4,_II

;==================================
; Re rempli la string avec ce qui
;  dj t rempli
;==================================

	move.l		pos,a0					; a0 = adr. du stockage
	lea			StrInput,a1				; a1 = adr. de la chaine
	clr.w		d4
_INbc00:								; on copie la string rentre auparavant
	tst.b		(a0)
	beq			_INbc01					; si 0 de fin, on quitte
	addq.w		#1,d4					; d4 = nb de carac imprimables
	move.b		(a0)+,(a1)+				
	bra			_INbc00					
_INbc01:

;====

	lea			StrInput,a0	
	move.w		d3,d5				; d5 = max carac
	subq.w		#1,d5				; d5 --
	mulu.w		#7,d5				; (max char - 1) * 7
	move.l		a0,a1				; a1 = a0
	add.l		d4,a0

_I01:
	move.b		#124,(a0)			; la '|' est mise en fin de chaine
	clr.b		1(a0)				; on met un zro de fin  aprs le "|"

\WaitKey:
	bsr			Print				; affiche la chaine
	move.l		a0,pos

;================
;= Attend...
;================
	
	movem.l		d1-d7/a0-a6,-(a7)
	
\APD_reset:
	movem.l		d1-d7/a0-a6,-(a7)
	push.w		#2
	jsr			doorsos::OSTimerRestart		; resets APD timer
	addq.l		#2,a7
	movem.l		(a7)+,d1-d7/a0-a6

	clr.w		d5
	clr.w		d4

\keyloop:
	add.w		#1,d4
	cmp.w		#$FFF,d4
	bne			\keyloop0

	clr.w		d4
	movem.l		d1-d7/a0-a6,-(a7)
	move.l		a6,-(a7)
	jsr			doorsos::ST_showHelp			; affiche l'aide
	lea			4(a7),a7
	movem.l		(a7)+,d1-d7/a0-a6

\keyloop0:
	addq.w		#1,d5
	cmp.w		#$4FFF,d5
	bne			\keyloop2
	clr.w		d5
	eor.b		#$5C,(a0)
	bsr			Print						; affiche la chaine

\keyloop2:
	movem.l		d1-d7/a0-a6,-(a7)
	move.w		#2,-(a7)
	jsr			doorsos::OSTimerExpired		; if APD expired..
	addq.l		#2,a7
	movem.l		(a7)+,d1-d7/a0-a6
	tst.w		d0
	beq			\noshutdown

\shutdown:
	trap		#4							; then shut down
	bra			\APD_reset

\noshutdown:
	tst.w		KEY_PRESSED_FLAG			; has a key been pressed ?
	beq			\keyloop					; no..
	
	movem.l		d1-d7/a0-a6,-(a7)
	jsr			doorsos::ngetchx			; yes : get the key code
	movem.l		(a7)+,d1-d7/a0-a6

	cmp.w		#KEY_DIAMOND+$10B,d0		; Diamand+ON shuts down the calc
	beq			\shutdown
	move.w		d0,d6
	
	movem.l		d1-d7/a0-a6,-(a7)
	push.w		#3
	jsr			doorsos::ST_busy			; clears BUSY flag
	addq.l		#2,a7
	movem.l		(a7)+,d1-d7/a0-a6

	move.w		d6,d0

	movem.l		(a7)+,d1-d7/a0-a6

;================
;= Fin Attend...
;================
			
	cmp.w		#13,d0				; Enter?
	beq			\Enter
	cmp.w		#257,d0				; Backspace?
	beq			\BackSp
	cmp.w		#264,d0				; Esc?
	beq			\Esc

	cmp.w		#KEY_UP,d0			; up?
	beq			\Pad
	cmp.w		#KEY_DOWN,d0		; down?
	beq			\Pad

	cmp.w		#255,d0				; autres carac affichables?
	bhi			\WaitKey			;
	cmp.w		d3,d4          		; nbchar = max carac ?
	beq			\WaitKey			;
	move.b		d0,(a0)+			; on stocke le carac en fin de caine
	addq.w		#1,d4				; nb carac + 1
	bra			_I01

;=============
; BackSp
;=============

\BackSp								
	tst.w		d4					; nb char == 0 
	beq			\WaitKey			;
	subq.w		#1,d4				; nb carac - 1
	subq.l		#1,a0				; 
	bra			_I01				; on retourne pour afficher

;=============
; Pad
;=============

\Pad
	moveq.w		#2,d6
	move.w		d0,d7
	bra			\Enter

;=============
; Esc
;=============

\Esc
	move.l		a1,a0				; ESC
	moveq.w		#1,d6

;=============
; Enter
;=============


\Enter								; ENTER
	clr.b		(a0)				; met un zero de fin  la sring

_E00:
	bsr			Print				; Redessine le string sans "|"
	clr.w		d0
	cmp.w		#1,d6
	bne			_E000
	move.w		#$FFFF,d0

_E000:
	cmp.w		#2,d6
	bne			\end
	move.w		d7,d0

;=============================
; FIN DE LA ROUTINE
;=============================

\end
	lea			StrInput,a0
	movem.l		(a7)+,d1-d7/a1		
	rts	

;============================================
; EFFACEMENT - AFFICHAGE D'UNE STRING
;============================================


Print:
	movem.l		d0-d7/a0-a6,-(a7)
	move.l		a1,a0
	jsr			graphlib::getlength	; d3 = longueur de la string , d4 = hauteur
	move.w		d1,d0				; x
	move.w		d2,d1				; y
	move.w		d3,d2				; longueur
	moveq.w		#7,d3				; hauteur
	moveq.w		#1,d4				; blanc
	addq.w		#5,d2
		
	jsr			graphlib::fill		; clear the background

	WriteStrA	d0,d1,#4,a1

	movem.l		(a7)+,d0-d7/a0-a6
	rts

;***************************************************************
;* Routine retournant la liste de nom et en d0 l'index du nom
;* choisit par l'utilisateur (=0 si non Enter)
;* input : d3 n du nom  slectionn (au dbut) 
;***************************************************************

;===========================
; Vrification du nb de nom
;===========================

_Liste:
	movem.l		d1-d7/a0-a6,-(a7)		; on sauve les registres

	bsr			_Adr					; retourne dans a0 l'adresse de 'annu'
	move.w		(a0)+,d0				; dtermine taille de 'annu'
	move.w		d0,taille				; sauve la taille

	cmp.w		#48,d0
	bne			_L00

	lea			err_nom,a6				; pas de nom stock dans annu !
	bsr			_Dialog
	clr.w		d0
	bra			_L12

;=======================
; Affichage de la liste
;=======================

_L00:
	bsr			_Nbnom	
	move.w		d0,d2					; d2 = nb de nom
	move.w		#55,d0					; d0 = x
	move.w		#11,d1					; d1 = y

	bsr			_Menu					; on affiche le menu

	tst.w		d2						; on vrifie que ENTER
	beq			_L12					; alors on ne met pas a 0 d0
	clr.w		d0

;===========================
; dernire frappe = lettre
;===========================

	cmp.w		#96,d1
	bls			_L12					; carac inferieur  'a' -> quit
	cmp.w		#122,d1
	bhi			_L12					; carac superieur  'z' -> quit

	sub.w		#32,d1					; transformation minuscule->MAJUSCULE
	lsl.w		#8,d1					; deplacement d'1 bytes vers gauche
	move.w		d1,var					; comme ca : code ASCII touche est (var)

;=======================
; On quitte...
;=======================

_L12:
	movem.l		(a7)+,d1-d7/a0-a6		; on restaure les registres

	rts

;*************************************************************************
;*  Routine retournant une liste d'item, sorte de menu droulant		 *	
;*	input : d0 = X					output : d0 = n lment selectionn *
;*			d1 = Y							 d1 = dernire touche frapp *
;*			d2 = nb-item					 d2 = 0 si ENTER			 *
;*			a0 = pointeur sur la liste									 *
;*			d3 = index du nom a surligner								 *
;*************************************************************************

_Menu:
	movem.l		d3-d7/a0-a6,-(a7)
	lea			handle,a5
	move.w		d2,nbitem				; nbitem est le nb total de nom
	move.w		d3,a4					; on sauve d3 momentanment

;=========================
; On cherche la lg max des 
; differents mots...
;=========================

	movem.l		d2/a0,-(a7)
	subq.w		#1,d2					; nbitem --
	clr.w		d5						; d5 = largeur max menu (mise  0)
_sm00:
	jsr			graphlib::getlength		; d3 = lg  d4 = haut
	cmp.w		d3,d5					; si (d3 <= d5)
	bge			_sm01					; on ne fait rien
	move.w		d3,d5					; sinon on met  jour d5
_sm01:
	add.l		#152,a0					; on passe au mot suivant
	dbra		d2,_sm00
	movem.l		(a7)+,d2/a0	

;===============================
; 2-3 calculs de prparation
;    =>hauteur total et largeur
;===============================

	move.w		#1,pos					; n du 1 nom du cadre
	move.w		#1,nblim				; n du nom slectionn dans le cadre

	move.w		d5,d7				
	addq.w		#5,d7					; LARGEUR TOTALE = d7

	clr.l		d6
	addq.w		#5,d4					
	move.w		d4,d6					; d4 = hauteur d'un mot
	mulu		d2,d6					; HAUTEUR TOTALE = d6

;===============================
; Vrification du "non-sortage"
; de l'cran...
;===============================

	move.w		d1,d5
	add.w		d6,d1
	cmp.w		#LCD_HEIGHT,d1			; d1 = y + hauteur total du menu
	bls			_Sauve					; si a ne sort pas, on saute...

;=============================
; La liste sort de l'cran...
;=============================

	move.w		d5,d1					; d1 = y (restauration)
	
	clr.l		d3
	move.w		#LCD_HEIGHT,d3
	sub.w		d1,d3					; d3 = dist. (menu->bas ecran)
	divu		d4,d3					; d4 = hauteur d'un mot
	move.w		d3,d2					; d2 = nb d'element max affichable

	move.w		d4,d6					; d4 = haut d'1 element
	mulu		d2,d6					; HAUTEUR TOTALE max = d6

	addq.w		#7,d7					; LARGEUR TOTALE + 7 = d7

;===============================
; Sauve la zone du menu
;===============================

_Sauve
	move.w		d5,d1					; d1 = y (restauration)
	movem.l 	d0-d4/a0,-(a7)

	move.w		a4,d3					; d3 = n du 1 nom surlign

	move.w		d3,pos
	move.w		d2,d1
_Sau00:
	add.w		pos,d2
	subq.w		#1,d2
	cmp.w		nbitem,d2
	ble			_Sau01

	move.w		d1,d2
	subq.w		#1,pos
	addq.w		#1,nblim
	bra			_Sau00

;=======
; Sauve
;=======

_Sau01:
	movem.l		(a7),d0-d4/a0
	lsr.w		#3,d0					; x/8 = x en bytes
	move.w		d6,d3					; d3 = HAUTEUR TOTALE
	addq.w		#1,d3
	move.w		d7,d2					; d2 = LARGEUR TOTALE
	lsr.w		#3,d2					; d2/8 -> largeur en bytes
	addq.w		#2,d2					; +2 pour etre sure
	jsr			graphlib::scrtomem		; sauve...
	tst.w		d4						; d4 = 0 ? 
	beq			non_cree
	movem.w		d0-d4,(a5)

;===============================
; Affiche nb de nom
;===============================

	clr.l		d0
	bsr			_Nbnom
	Nb_Str		d0,format,nb_str
	clr.w		d5
	WriteStr	d5,#116,#0,nb_str
	lea			nb_str,a0
	jsr			graphlib::getlength
	add.w		d3,d5
	WriteStr	d5,#116,#0,listnom

;===============================
; Affiche liste
;===============================

	movem.w		(a5),d0-d4
	bra			_refresh1				; dessine le tout...

;===============================
; Touches...
;===============================

Waitkey:
	move.w		d0,d5					; on sauve le x pour le surlignement
waitkey
	lea			datehelp,a6
	bsr			_idle_loop				; attend l'appui d'une touche
	cmp.w		#KEY_UP,d0				; UP	?
	beq			padup
	cmp.w		#KEY_DOWN,d0			; DOWN	?
	beq			paddown	
	cmp.w		#13,d0					; ENTER	?	
	beq 		fin
	cmp.w		#265,d0					; caract affichable ??	
	bhi 		waitkey

	bra			esc

;========
; Haut
;========

padup:
	move.w		d5,d0
	jsr			graphlib::fill			; on de-surligne
	movem.l		(a7),d0-d4/a0

	subq.w		#1,nblim				; selected item --
	bne			_pu00					;  si =!0  , on rafraichit uniquement
	cmp.w		nbitem,d2				; cas d'un menu droulant ou non ?
	bne			_defil_haut
	move.w		d2,nblim				; item selectionn = le dernier item
_pu00:
	bra			refresh2				; on rafraichit

;========
; Bas
;========

paddown:
	move.w		d5,d0
	jsr			graphlib::fill			; on de-surligne
	movem.l		(a7),d0-d4/a0

	cmp.w		nblim,d2
	bne			_pd00					; si tout en bas alors retour haut
	cmp.w		nbitem,d2				; cas d'un menu droulant ou non ?
	bne			_defil_bas
	clr.w		nblim
_pd00:
	addq.w		#1,nblim				; selected item ++
	bra			refresh2				; on racfraichit

;================
; End
;================

fin:
	clr.l		d7						; Enter a t frapp
esc:
	move.w		d0,d5					; on sauve la dernire touche frapp
	add.l		#24,a7					; car 6 registres sont sur le stack

	movem.w		(a5),d0-d4
	jsr			graphlib::memtoscr		; restauration de l'cran

	move.w		d5,d1					; d1 = last pressed key
	move.w		nblim,d0
	add.w		pos,d0
	subq.w		#1,d0					; d0 = nom selectionn
	move.w		d7,d2
	movem.l		(a7)+,d3-d7/a0-a6

	rts									; QUIT tout

;=========
; Mem Err
;=========

non_cree:								
	move.w		#264,d1					; d1 = dernire touche
	moveq.w		#1,d2					; d2 =! 0 =! ENTER
	clr.w		d0						; d0 = lment selectionn
	movem.l		(a7)+,d3-d7/a0-a6
	rts									; QUIT tout

;======================================================
; On traite le depassement de l'cran
;======================================================

;--------------------------
; Vers le bas
;--------------------------

_defil_bas:
	add.w		pos,d2
	subq.w		#1,d2
	move.w		nbitem,d1
	cmp.w		d1,d2					; si le cadre n'est pas en bas de liste
	bne			_def_b00				; on saute
	
	clr.w		pos						; on met le cadre tout en haut
	move.w		#1,nblim				; on met le cuseur sur le 1 nom du cadre
_def_b00:
	addq.w		#1,pos
	bra			_dF

;---------------------------
; Vers le haut
;---------------------------

_defil_haut:
	addq.w		#1,nblim				; on restaure nblim...
	cmp.w		#1,pos					; si le cadre n'est pas en haut de liste
	bne			_def_h00				; on saute
	
	move.w		nbitem,d1
	sub.w		d2,d1
	addq.w		#1,d1
	move.w		d1,pos					; on met le cadre tout en bas
	move.w		d2,nblim				; on met le cuseur sur le 1 nom du cadre
	bra			_dF

_def_h00:
	subq.w		#1,pos
_dF


;=============================================================================
; Trouve l'adresse a0 du dbut du cadre
;=============================================================================

_refresh1:
	movem.l		(a7),d0-d4/a0		
	move.w		pos,d5
	cmp.w		#1,d5
	beq			_refr11					; si cadre tout en haut, a0 = a1					
	subq.w		#1,d5

_refr10:
	mulu		#152,d5
	add.l		d5,a0

;===============================
; On efface...
;===============================

_refr11:
	move.w		d7,d2					; d2 = largeur totale
	move.w		d6,d3
	subq.w		#2,d3					; d3 = hauteur totale - 2
	moveq.w		#1,d4					; color = white
	jsr			graphlib::fill			; clear the background

;===============================
; Cadre....
;===============================

	move.w		d7,d4					; d4 = largeur totale
	move.w		d6,d5	
	subq.w		#1,d5					; d5 = hauteur pour frame
	jsr			graphlib::frame			; dessine le cadre

	
;===============================
; Affiche un item
;===============================				
	
	move.l		a0,a1					; on sauve a0
	movem.l		(a7),d0-d4/a0
	move.l		a1,a0					; on restaure a0

	subq.w		#1,d2

_refr12:
	movem.l		d0-d7/a0-a6,-(a7)
	addq.w		#2,d0					; x += 2	
	addq.w		#3,d1					; y += 3
	WriteStrA	d0,d1,#4,a0				; Affiche le nom (a0)
	movem.l		(a7)+,d0-d7/a0-a6

;===============================
; Trouve le mot suivant....
;===============================				

_refr13:
	add.l		#152,a0			
	add.w		d4,d1					; d1 = y + hauteur d'1 nom
	dbra		d2,_refr12				; on recommence jusqu' la fin des noms

;===============================
; Si menu droulant => Flches
;===============================
	
	movem.l		(a7),d0-d4/a0
	cmp.w		nbitem,d2				; cas d'un menu droulant ?
	beq			refresh2				; sinon on saute

	cmp.w		#1,pos
	beq			_refr14					; si le cadre est en haut, on saute...
	add.w		d7,d0					; d0 = x + largeur totale
	subq.w		#5,d0
	addq.w		#2,d1					; d1 = y + 2
	movem.w		d0-d2/d6-d7,-(a7)
	WriteStr	d0,d1,#4,Fl_haut		; on dessine la flche vers le haut
	movem.w		(a7)+,d0-d2/d6-d7

_refr14:
	movem.l		(a7),d0-d4/a0
	add.w		d7,d0					; d0 = x + largeur totale
	subq.w		#5,d0

	move.w		d2,d5
	add.w		pos,d5
	subq.w		#1,d5
	cmp.w		nbitem,d5				; si cadre en bas de liste, on saute...
	beq			refresh2
	subq.w		#1,d2
	mulu.w		d4,d2
	add.w		d1,d2
	addq.w		#2,d2
	movem.w		d6/d7,-(a7)
	WriteStr	d0,d2,#4,Fl_bas			; on dessine la flche bas
	movem.w		(a7)+,d6/d7
	

;=============================================================================
; On trouve la position y de l'lment slctionn
;=============================================================================

refresh2:
	movem.l		(a7),d0-d4/a0
	move.w		nblim,d5
	subq.w		#1,d5
	mulu		d4,d5
	add.w		d5,d1					; d1 = y de l'lment slctionn

;=================
; On le surligne
;=================

	addq.w		#1,d1					; y += 1
	addq.w		#1,d0					; x += 1
	move.w 		d7,d2
	subq.w		#2,d2					; d2 = largeur total - 2
	move.w		d4,d3
	subq.w		#3,d3					; d3 = hauteur d'1 nom - 3

	clr.w		d4						; 0 = couleur = inversion
	jsr			graphlib::fill			; surligne l'element surlign
	bra			Waitkey

;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************
;**************************************************************************


;*************************************************************************
;*  Routine IDLE LOOP	
;*			a6 = adresse du commentaire		                                         *
;*************************************************************************

;================
;= Attend...
;================

_idle_loop

	movem.l		d1-d7/a0-a6,-(a7)
	
\APD_reset1:
	movem.l		d1-d7/a0-a6,-(a7)
	push.w		#2
	jsr			doorsos::OSTimerRestart		; resets APD timer
	addq.l		#2,a7
	movem.l		(a7)+,d1-d7/a0-a6

		clr.w		d4

\keyloop1:
	add.w		#1,d4
	cmp.w		#$FFF,d4
	bne			\keyloop10

	clr.w		d4
	movem.l		d1-d7/a0-a6,-(a7)
	move.l		a6,-(a7)
	jsr			doorsos::ST_showHelp			; affiche l'aide
	lea			4(a7),a7
	movem.l		(a7)+,d1-d7/a0-a6

\keyloop10:
	movem.l		d1-d7/a0-a6,-(a7)
	move.w		#2,-(a7)
	jsr			doorsos::OSTimerExpired		; if APD expired..
	addq.l		#2,a7
	movem.l		(a7)+,d1-d7/a0-a6
	tst.w		d0
	beq			\noshutdown1

\shutdown1:
	trap		#4							; then shut down
	bra			\APD_reset1

\noshutdown1:
	tst.w		KEY_PRESSED_FLAG			; has a key been pressed ?
	beq			\keyloop1					; no..
	
	movem.l		d1-d7/a0-a6,-(a7)
	jsr			doorsos::ngetchx			; yes : get the key code
	movem.l		(a7)+,d1-d7/a0-a6

	cmp.w		#KEY_DIAMOND+$10B,d0		; Diamand+ON shuts down the calc
	beq			\shutdown1
	move.w		d0,d6
	
	movem.l		d1-d7/a0-a6,-(a7)
	push.w		#3
	jsr			doorsos::ST_busy			; clears BUSY flag
	addq.l		#2,a7
	movem.l		(a7)+,d1-d7/a0-a6

	move.w		d6,d0

	movem.l		(a7)+,d1-d7/a0-a6

;================
;= Fin Attend...
;================
	
	rts

;*************************************************************************
;*  Routine de mise au point :                                           *
;*    . le registre D6 en hexadcimal									 *
;*************************************************************************

Debug:
	movem.l	d0-d7/a0-a6,-(a7)
	lea		DebugStr,a5

	bsr		DB10
	bsr		DB10
	add.l	#1,a5
	bsr		DB10
	bsr		DB10
	add.l	#1,a5
	bsr		DB10
	bsr		DB10
	add.l	#1,a5
	bsr		DB10
	bsr		DB10

	WriteStr	#70,#70,#4,DebugStr
	lea			blanc,a6
	bsr			_idle_loop
	movem.l (a7)+,d0-d7/a0-a6

	rts

;**** mise en place d'un digit hexadcimal

DB10:
	rol.l	#4,d6
	move.b	d6,d0
	and.b	#$0F,d0
	or.b	#$30,d0
	cmp.b	#$3A,d0
	blt		DB11
	add.b	#$07,d0
DB11:
	move.b	d0,(a5)+
	rts

DebugStr  dc.b ".. .. .. ..",0

;*************************************************************************
;*  Variables diverses et varies                                        *
;*************************************************************************

;================
; Variable (nb)
;================

vatadr		dc.l	0				; adresse de 'annu' en VAT
taille		dc.w	0				; taille en bytes de 'annu'
pos			dc.l	0				; position pour le stockage
pos2		dc.l	0
var			dc.w	0				; variable qui peut servir un peu partout
nblim		dc.w	0				; index de pointage pour fct smallmenu
nbitem		dc.w	0				; nombre d'lment dans routine smallmenu
archive		dc.w	0				; si annu arch = 1

;=================
; Textes
;=================

format		dc.b	"%d",0
nb_str		dc.b	"  ",0

StrInput	dc.b	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

titre		dc.b    "F1-Noms      F2-Date      F3-Gestion      F4-A Propos",0

noms		dc.b    "Liste des noms",0
			dc.b    "Chercher",0

dates		dc.b    "Chercher",0

gest		dc.b    "Ajouter",0
			dc.b    "Modifier",0
			dc.b    "Supprimer",0

name1		dc.b	"nom",0
name2		dc.b	"annu",0

listnom		dc.b	" noms",0
listdate	dc.b	" personnes conviennent  votre recherche",0

datehelp	dc.b	"Utiliser ",20,19," pour visionner les noms",0

form1		dc.b	"Nom :",0
form2		dc.b	"Adresse :",0
form3		dc.b	"Ville :",0
form4		dc.b	"Tlphone : .. .. .. .. ..",0
form5		dc.b	"Portable : .. .. .. .. ..",0
form6		dc.b	"Anniversaire : ../../..",0
form7		dc.b	"Fte : ../..           ",0
form8		dc.b	"E-mail :",0

copyr1		dc.b	"Annuaire par El Isard",0
copyr2		dc.b	"Version 0.98",0
copyr3		dc.b	"El.Isard@wanadoo.fr",0
copyr4		dc.b	"http://www.ti-isard.fr.st",0

blanc		dc.b	" ",0
trouver		dc.b	"Entrer le nom (ou une partie du nom) :",0
date		dc.b	"Entrer la date (mm/aa):",0

annif1		dc.b	" aura",0
annif2		dc.b	"ans le",0
fete1		dc.b	" aura sa fete le",0

Att			dc.b	"ATTENTION",0
Eff			dc.b	"SUPPRIMER ?",0
Sau			dc.b	"SAUVEGARDER ?",0
Qui			dc.b	"QUITTER ?",0

Err			dc.b	"ERREUR",0
Mem			dc.b	"MANQUE DE MEMOIRE",0
Nom			dc.b	"AUCUN NOM EN MEM.",0
Find		dc.b	"RECHERCHE INFRUCTUEUSE",0
Date		dc.b	"DATE INVALIDE",0

Fl_haut		dc.b	19,0
Fl_bas		dc.b	20,0

;===================
; Autres
;===================

sauve		dc.l	Att,Sau

confirm		dc.l	Att,Eff

quit		dc.l	Att,Qui

err_mem		dc.l	Err,Mem

err_nom		dc.l	Err,Nom

err_find	dc.l	Err,Find

err_date	dc.l	Err,Date

handle		ds.b	10

;===================
; Image
;===================

image:
 dc.w 104,16
 dc.b %00000000
 dc.b %00000000
 dc.b %00100000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000001
 dc.b %11110000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000011
 dc.b %11101100
 dc.b %00001000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %01010111
 dc.b %10000110
 dc.b %00011100
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %11101111
 dc.b %00000000
 dc.b %00111100
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000001
 dc.b %11000111
 dc.b %00000000
 dc.b %00111100
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000101
 dc.b %01010101
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000001
 dc.b %10000111
 dc.b %00000000
 dc.b %00101100
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %11111111
 dc.b %11100000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000001
 dc.b %11000111
 dc.b %00010000
 dc.b %01011100
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %01111111
 dc.b %11111111
 dc.b %11110000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000001
 dc.b %10000111
 dc.b %00111000
 dc.b %11111100
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %11111111
 dc.b %11111111
 dc.b %11111110
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000001
 dc.b %11000111
 dc.b %00011001
 dc.b %11010100
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000001
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %11100011
 dc.b %10111000
 dc.b %10111000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11100000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %01110011
 dc.b %11111001
 dc.b %11110100
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00011111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11110100
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %01111011
 dc.b %10111001
 dc.b %10101000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111110
 dc.b %10000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00111101
 dc.b %11111101
 dc.b %11110000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000001
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %01000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00011111
 dc.b %11111111
 dc.b %11110000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000011
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %10100000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00011111
 dc.b %11111111
 dc.b %11100000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00011111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11110000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001100
 dc.b %11111111
 dc.b %11100000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11100000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00011001
 dc.b %11011111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000001
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11110000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001000
 dc.b %10111111
 dc.b %11100000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000011
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11100000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00010001
 dc.b %01111101
 dc.b %11110000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11110000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %11111111
 dc.b %11111000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11101111
 dc.b %11110000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %01111111
 dc.b %11111100
 dc.b %00000000
 dc.b %00000000
 dc.b %00011111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11000111
 dc.b %11110000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %11111111
 dc.b %11111110
 dc.b %00000000
 dc.b %00000000
 dc.b %10111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %10001111
 dc.b %11110000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000101
 dc.b %11111101
 dc.b %11111110
 dc.b %00000000
 dc.b %00000000
 dc.b %01111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %10000111
 dc.b %11110000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001011
 dc.b %11111010
 dc.b %11111110
 dc.b %00000000
 dc.b %00000010
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %10001111
 dc.b %11100000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000111
 dc.b %11110001
 dc.b %11111111
 dc.b %00000000
 dc.b %00000111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %10000101
 dc.b %11110000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00101111
 dc.b %11000010
 dc.b %11111111
 dc.b %10000000
 dc.b %00101111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %10001010
 dc.b %11100000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %01111111
 dc.b %10000001
 dc.b %11111111
 dc.b %00000000
 dc.b %01111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %10000000
 dc.b %11110000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001011
 dc.b %11111110
 dc.b %00000010
 dc.b %11111111
 dc.b %10000000
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %10001000
 dc.b %10100000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000111
 dc.b %11111100
 dc.b %00000001
 dc.b %11111111
 dc.b %11000001
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %00010001
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000111
 dc.b %00100000
 dc.b %00000010
 dc.b %11111111
 dc.b %11101011
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %10101010
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000110
 dc.b %00010000
 dc.b %00000000
 dc.b %11111111
 dc.b %11110111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %00010011
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000011
 dc.b %11111010
 dc.b %00000010
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %10101010
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000001
 dc.b %01011101
 dc.b %01010101
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %01110110
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %10001111
 dc.b %11101011
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111110
 dc.b %10101110
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %01111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %01011100
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %01111011
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111110
 dc.b %11111100
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %01111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111101
 dc.b %11111100
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00011111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00011111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00011111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11110000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11110000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11101111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11010111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111100
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000011
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %10101111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000001
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %10011111
 dc.b %11111111
 dc.b %11110111
 dc.b %11111100
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %10111111
 dc.b %11111111
 dc.b %11111011
 dc.b %11111110
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %01011111
 dc.b %01111111
 dc.b %11111101
 dc.b %11111100
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %01111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111110
 dc.b %10111110
 dc.b %01111111
 dc.b %11111111
 dc.b %11111110
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %01111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111101
 dc.b %01111100
 dc.b %00111111
 dc.b %11111111
 dc.b %11111111
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111010
 dc.b %11111000
 dc.b %00011111
 dc.b %11111110
 dc.b %10111111
 dc.b %10000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00011111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11000000
 dc.b %00001111
 dc.b %11111111
 dc.b %01111111
 dc.b %10000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %10000000
 dc.b %00000111
 dc.b %11111111
 dc.b %11111111
 dc.b %10000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000011
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111100
 dc.b %00000000
 dc.b %00000011
 dc.b %11111111
 dc.b %11111111
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %11111111
 dc.b %11111111
 dc.b %11111110
 dc.b %11111111
 dc.b %11101000
 dc.b %00000000
 dc.b %00000001
 dc.b %11111111
 dc.b %11111110
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %01111111
 dc.b %11111111
 dc.b %11111101
 dc.b %11111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %11111111
 dc.b %11111110
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111110
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %11111111
 dc.b %10111110
 dc.b %00000000
 dc.b %00000000
 dc.b %10000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %01111111
 dc.b %01111100
 dc.b %00000000
 dc.b %00000000
 dc.b %01000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00011111
 dc.b %11111111
 dc.b %11111011
 dc.b %11111110
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %01111111
 dc.b %01111100
 dc.b %00000000
 dc.b %00000010
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00011111
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %01111111
 dc.b %01111100
 dc.b %00010001
 dc.b %00000101
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %11111111
 dc.b %11111011
 dc.b %11111110
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %01111110
 dc.b %01111010
 dc.b %00101010
 dc.b %10001011
 dc.b %10000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000001
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %01111100
 dc.b %01111100
 dc.b %01000101
 dc.b %00010101
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %11111011
 dc.b %11111110
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %01111010
 dc.b %11111010
 dc.b %10001010
 dc.b %00001111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %11111101
 dc.b %11111110
 dc.b %00000000
 dc.b %00000000
 dc.b %00000101
 dc.b %01111111
 dc.b %11110101
 dc.b %11010111
 dc.b %00011111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %11111001
 dc.b %11111110
 dc.b %00000000
 dc.b %00000000
 dc.b %00000010
 dc.b %11111011
 dc.b %11111110
 dc.b %11111111
 dc.b %10101111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %11111101
 dc.b %11111100
 dc.b %00000000
 dc.b %00000101
 dc.b %01010111
 dc.b %11110101
 dc.b %11110111
 dc.b %11111111
 dc.b %01011111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %11111001
 dc.b %11111110
 dc.b %00000000
 dc.b %00000000
 dc.b %00001011
 dc.b %11111110
 dc.b %11101111
 dc.b %11111110
 dc.b %10111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %11111001
 dc.b %11111100
 dc.b %00000000
 dc.b %00000000
 dc.b %00000101
 dc.b %11110101
 dc.b %11110111
 dc.b %11111100
 dc.b %01111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %11111001
 dc.b %11111100
 dc.b %00000000
 dc.b %00000000
 dc.b %00101011
 dc.b %11101111
 dc.b %11101111
 dc.b %11111000
 dc.b %11111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %11110001
 dc.b %11111100
 dc.b %00000000
 dc.b %00000000
 dc.b %01110111
 dc.b %11111111
 dc.b %11111111
 dc.b %11110001
 dc.b %01111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %11110001
 dc.b %11111000
 dc.b %00000000
 dc.b %00001000
 dc.b %10111111
 dc.b %11101111
 dc.b %11101111
 dc.b %11100011
 dc.b %11111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %11110001
 dc.b %11111100
 dc.b %00000000
 dc.b %01010001
 dc.b %01010111
 dc.b %11011111
 dc.b %11011111
 dc.b %11000111
 dc.b %11111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %11100001
 dc.b %11111000
 dc.b %00000010
 dc.b %10100000
 dc.b %11101111
 dc.b %11111111
 dc.b %11001110
 dc.b %00000110
 dc.b %11111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %11100001
 dc.b %11111000
 dc.b %00000001
 dc.b %01010101
 dc.b %01010111
 dc.b %11011111
 dc.b %11011100
 dc.b %00000101
 dc.b %11111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %11100001
 dc.b %11111000
 dc.b %00000010
 dc.b %10101010
 dc.b %10101111
 dc.b %10111011
 dc.b %10111000
 dc.b %00001011
 dc.b %11111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %11000001
 dc.b %11111000
 dc.b %00010001
 dc.b %01010111
 dc.b %11011111
 dc.b %11110111
 dc.b %11110000
 dc.b %00001111
 dc.b %11111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %11000000
 dc.b %11111000
 dc.b %00101010
 dc.b %10101010
 dc.b %11111111
 dc.b %10111111
 dc.b %11100000
 dc.b %00001111
 dc.b %11111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000111
 dc.b %11000000
 dc.b %11111000
 dc.b %00000101
 dc.b %11011111
 dc.b %11111101
 dc.b %01111111
 dc.b %00000000
 dc.b %00001111
 dc.b %11111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %10000000
 dc.b %11111000
 dc.b %00000010
 dc.b %10101111
 dc.b %11111111
 dc.b %10111000
 dc.b %00000000
 dc.b %00001111
 dc.b %11111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000111
 dc.b %10000000
 dc.b %01110000
 dc.b %00010101
 dc.b %01111111
 dc.b %11111111
 dc.b %01110000
 dc.b %00000000
 dc.b %00000111
 dc.b %11111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %10000000
 dc.b %01111000
 dc.b %00001010
 dc.b %11101111
 dc.b %11101111
 dc.b %11100000
 dc.b %00000000
 dc.b %00000010
 dc.b %10111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000111
 dc.b %00000000
 dc.b %01111000
 dc.b %00010001
 dc.b %01110111
 dc.b %11111101
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00011111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %10000000
 dc.b %00111000
 dc.b %00101011
 dc.b %10111111
 dc.b %11111111
 dc.b %10000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000111
 dc.b %00000000
 dc.b %01111001
 dc.b %01010101
 dc.b %01111111
 dc.b %11111100
 dc.b %00000000
 dc.b %00000000
 dc.b %00000101
 dc.b %01011111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %10000000
 dc.b %00111010
 dc.b %00101111
 dc.b %10101111
 dc.b %11111000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %10111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %00000000
 dc.b %00111100
 dc.b %01011111
 dc.b %11111111
 dc.b %11000000
 dc.b %01000111
 dc.b %11111100
 dc.b %00000101
 dc.b %01011111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %10000000
 dc.b %00111000
 dc.b %00101111
 dc.b %11111010
 dc.b %00000001
 dc.b %10001111
 dc.b %11111110
 dc.b %00101010
 dc.b %10111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %00000000
 dc.b %00111100
 dc.b %01011111
 dc.b %11110000
 dc.b %00000011
 dc.b %10011111
 dc.b %11111111
 dc.b %00000101
 dc.b %01111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001110
 dc.b %10000000
 dc.b %00111110
 dc.b %00111111
 dc.b %11100000
 dc.b %00000111
 dc.b %10111111
 dc.b %11111111
 dc.b %10001010
 dc.b %10111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00011111
 dc.b %00000000
 dc.b %00111110
 dc.b %00111111
 dc.b %00000000
 dc.b %00000111
 dc.b %00111111
 dc.b %11111111
 dc.b %11000101
 dc.b %01111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00011111
 dc.b %10000000
 dc.b %00111110
 dc.b %11111110
 dc.b %00000000
 dc.b %00101110
 dc.b %01111111
 dc.b %11111111
 dc.b %11101010
 dc.b %10111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00011111
 dc.b %00000000
 dc.b %00111111
 dc.b %11111100
 dc.b %01010100
 dc.b %01011100
 dc.b %01111111
 dc.b %11011111
 dc.b %11110101
 dc.b %01111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00011110
 dc.b %00000000
 dc.b %00111111
 dc.b %11111000
 dc.b %10101000
 dc.b %11111000
 dc.b %11111011
 dc.b %11111111
 dc.b %11111010
 dc.b %11111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00011111
 dc.b %00000000
 dc.b %00111111
 dc.b %11110001
 dc.b %11010001
 dc.b %01010001
 dc.b %11110111
 dc.b %11111111
 dc.b %11111101
 dc.b %01111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00111111
 dc.b %00000000
 dc.b %00111111
 dc.b %11100010
 dc.b %10101011
 dc.b %10111011
 dc.b %10101111
 dc.b %11111111
 dc.b %11111010
 dc.b %11111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %01111111
 dc.b %00000000
 dc.b %01111111
 dc.b %10010101
 dc.b %01010101
 dc.b %01110111
 dc.b %01011111
 dc.b %11111111
 dc.b %11111101
 dc.b %11111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %11111111
 dc.b %00000000
 dc.b %11111110
 dc.b %00101011
 dc.b %11101010
 dc.b %11101110
 dc.b %10111111
 dc.b %11111111
 dc.b %11111011
 dc.b %11111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %01111100
 dc.b %00000001
 dc.b %11111100
 dc.b %01010111
 dc.b %01011101
 dc.b %11011101
 dc.b %01111111
 dc.b %11111111
 dc.b %11111101
 dc.b %11111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %11111110
 dc.b %10111111
 dc.b %11100010
 dc.b %10101110
 dc.b %10111011
 dc.b %10111010
 dc.b %10111111
 dc.b %11111111
 dc.b %11111011
 dc.b %11111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %11111111
 dc.b %11111111
 dc.b %01000101
 dc.b %01011101
 dc.b %01010111
 dc.b %01110101
 dc.b %11111111
 dc.b %11111111
 dc.b %11110101
 dc.b %11111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000011
 dc.b %11111111
 dc.b %11111110
 dc.b %00000010
 dc.b %11111010
 dc.b %10101110
 dc.b %11111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11101010
 dc.b %11111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000111
 dc.b %11111111
 dc.b %11110000
 dc.b %01000111
 dc.b %11010101
 dc.b %11011101
 dc.b %01111111
 dc.b %11111111
 dc.b %11111111
 dc.b %11110101
 dc.b %01011101
 dc.b %11000000













image2:
  dc.w 58,5
 dc.b %00000000
 dc.b %00000000
 dc.b %00000010
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00011111
 dc.b %11000000
 dc.b %00010000
 dc.b %00000000
 dc.b %00000000
 dc.b %00111111
 dc.b %11100000
 dc.b %00011000
 dc.b %00000000
 dc.b %00000000
 dc.b %01111100
 dc.b %01110000
 dc.b %00011000
 dc.b %00000000
 dc.b %00001110
 dc.b %01111000
 dc.b %00011000
 dc.b %00111000
 dc.b %00000000
 dc.b %01111111
 dc.b %01110000
 dc.b %00000000
 dc.b %01111100
 dc.b %00000000
 dc.b %01111000
 dc.b %11110000
 dc.b %00000000
 dc.b %11111000
 dc.b %00000000
 dc.b %01110000
 dc.b %11110000
 dc.b %00000000
 dc.b %11111100
 dc.b %00000000
 dc.b %01100000
 dc.b %11100000
 dc.b %10000000
 dc.b %11111000
 dc.b %00000000
 dc.b %01110000
 dc.b %11110001
 dc.b %10000001
 dc.b %11111100
 dc.b %00000000
 dc.b %01110000
 dc.b %11110000
 dc.b %10000011
 dc.b %10101000
 dc.b %00000000
 dc.b %01110000
 dc.b %01110001
 dc.b %11000011
 dc.b %01111100
 dc.b %00000000
 dc.b %00111000
 dc.b %01111011
 dc.b %11000011
 dc.b %11101000
 dc.b %00000000
 dc.b %00111100
 dc.b %01111011
 dc.b %11000111
 dc.b %01011000
 dc.b %00000000
 dc.b %00111110
 dc.b %00111011
 dc.b %11100111
 dc.b %11101000
 dc.b %00000000
 dc.b %00011111
 dc.b %00111111
 dc.b %11010111
 dc.b %01010000
 dc.b %00000000
 dc.b %00001111
 dc.b %10111110
 dc.b %10111111
 dc.b %11110000
 dc.b %00000000
 dc.b %00000111
 dc.b %11011111
 dc.b %11111111
 dc.b %11110000
 dc.b %00000000
 dc.b %00000011
 dc.b %11111111
 dc.b %11111111
 dc.b %11100000
 dc.b %00000000
 dc.b %00000001
 dc.b %11011111
 dc.b %11111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000011
 dc.b %10101111
 dc.b %11111111
 dc.b %10000000
 dc.b %00000000
 dc.b %00000001
 dc.b %00011111
 dc.b %11111111
 dc.b %11000000
 dc.b %00000000
 dc.b %00000010
 dc.b %00001110
 dc.b %10111111
 dc.b %10000000
 dc.b %00000000
 dc.b %00000001
 dc.b %00011101
 dc.b %11111111
 dc.b %11100000
 dc.b %00000000
 dc.b %00000010
 dc.b %00111011
 dc.b %11111111
 dc.b %11110000
 dc.b %00000000
 dc.b %00000000
 dc.b %00010111
 dc.b %11111111
 dc.b %11110000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000111
 dc.b %11111111
 dc.b %11111000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000111
 dc.b %11111111
 dc.b %11111100
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %11111111
 dc.b %11111110
 dc.b %00000000
 dc.b %00000000
 dc.b %01011111
 dc.b %11110111
 dc.b %11111100
 dc.b %00000000
 dc.b %00000000
 dc.b %10101111
 dc.b %11101011
 dc.b %11111110
 dc.b %00000000
 dc.b %00000001
 dc.b %01111111
 dc.b %01010111
 dc.b %11111111
 dc.b %00000000
 dc.b %00000000
 dc.b %11111110
 dc.b %00101011
 dc.b %11111111
 dc.b %00000000
 dc.b %00000101
 dc.b %11111100
 dc.b %00010111
 dc.b %11111111
 dc.b %00000000
 dc.b %00001111
 dc.b %11111000
 dc.b %00001011
 dc.b %11111111
 dc.b %00000000
 dc.b %01111111
 dc.b %11110000
 dc.b %00000111
 dc.b %11111111
 dc.b %00000011
 dc.b %11111111
 dc.b %10100000
 dc.b %00001011
 dc.b %11111111
 dc.b %00000111
 dc.b %11100111
 dc.b %00000000
 dc.b %00000111
 dc.b %11111111
 dc.b %00000011
 dc.b %10001010
 dc.b %00000000
 dc.b %00001011
 dc.b %11111111
 dc.b %00000001
 dc.b %00000001
 dc.b %00000000
 dc.b %00000011
 dc.b %11111111
 dc.b %00000011
 dc.b %10101110
 dc.b %10100000
 dc.b %00000011
 dc.b %11111111
 dc.b %00000001
 dc.b %11110111
 dc.b %01010100
 dc.b %01010111
 dc.b %11111111
 dc.b %00000000
 dc.b %10001111
 dc.b %11111010
 dc.b %10101111
 dc.b %11111111
 dc.b %00000000
 dc.b %00000001
 dc.b %11111111
 dc.b %01011111
 dc.b %11111111
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %11111111
 dc.b %11111111
 dc.b %00000000
 dc.b %00000000
 dc.b %00000111
 dc.b %11011111
 dc.b %11111111
 dc.b %00000000
 dc.b %00000000
 dc.b %00000011
 dc.b %11111111
 dc.b %11111111
 dc.b %00000000
 dc.b %00000000
 dc.b %00000001
 dc.b %11111111
 dc.b %11111111
 dc.b %00000000
 dc.b %00000000
 dc.b %00000011
 dc.b %11111111
 dc.b %11111111
 dc.b %00000000
 dc.b %00000000
 dc.b %00000001
 dc.b %11111111
 dc.b %11111111
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %11111111
 dc.b %11111111
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %11111111
 dc.b %11111111
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %11111111
 dc.b %11111111
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %01111111
 dc.b %11111111
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %01111111
 dc.b %11111111
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00111111
 dc.b %11111111
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00111111
 dc.b %11111111
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00011111
 dc.b %11111111

_comment	dc.b	"Annuaire par Isard",0
	end			    